<?php

class EventsController extends Controller {
    function viewall($type=NULL) {
        $this->admin(true);
        $this->render = 0;
        if (isset($type)) {
            if ($type=="html") {
                echo json_encode(array("status"=>true, "html"=>Event::html_admin_list(new HTML())));
            }
        }
        exit;
    }
    
    function delete() {        
        $status = false;
        $message = "Unknown event id";        
        $this->render = 0;
        
        if (isset($_POST['id'])) {
            $this->Event->id = $_POST['id'];
            if ($this->Event->delete()) {
                $status = true;
                $message = 'Event deleted successfully';            
            } else {
                $message = 'An error occurred.';
            }
        }
        
        echo json_encode(array('status'=>$status, 'message'=>$message));
        exit;
    }
    
    function view($id=null) {
        $data = array('Event' => array('additional_topics'=>array()));
        $this->admin(true);
        $this->doNotRenderHeader = 1;
        $this->set('title', 'Event');        

        $industry = new Industry();
        $industry->orderBy('place_order');
        $this->set('industries', $industry->get_industries());

        if ($id!==null) {
            $this->Event->id = $id;
            $data = $this->Event->search();            
            $data['Event']['additional_topics'] = explode(';', $data['Event']['topics']);
        }        
        $this->set('data', $data);
    }
    
    function save() {
        if (isset($_POST['Do']) && $_POST['Do']=="Submit") {
            $this->render = 0;
            
            $event = new Event();
            if (isset($_POST['id']) && is_numeric($_POST['id']) && $_POST['id']>0) {
                $event->id = $_POST['id'];
            } else {
                $event->place_order = $event->maxPlace();
            }
            
            $event->city = $_POST['city'];
            $event->date = $_POST['date'];
            $event->location = $_POST['location'];
            $event->speaker_detail = $_POST['speaker_detail'];
            $event->learn_more_button = $_POST['learn_more_button'];
            $event->learn_more_link = $_POST['learn_more_link'];
            $event->register_button = $_POST['register_button'];
            $event->register_link = $_POST['register_link'];

            if (isset($_POST['additional_topics'])) $event->topics = implode(';', $_POST['additional_topics']);
            else $event->topics = '';
            
            $event->write_in_topic = $_POST['write_in_topic'];
            $event->write_in_topic_link = $_POST['write_in_topic_link'];
            $event->x_pos = $_POST['x_pos'];
            $event->y_pos = $_POST['y_pos'];

            $id = $event->save();

            echo json_encode(array('status'=>true, 'message'=>'Event saved successfully.'));
            exit;
        }
    }
    
    function moveup($id) {
        $this->render = 0;
        $this->Event->id = $id;
        $res = $this->Event->move(-1);
        
        echo json_encode(array('status'=>true, 'message'=>'Event moved up successfully'));
        exit;
    }

    function movedown($id){
        $this->render = 0;
        $this->Event->id = $id;
        $res = $this->Event->move(1);
        
        echo json_encode(array('status'=>true, 'message'=>'Event moved down successfully'));
        exit;
    }    
}
