<?php

class HomesController extends Controller {
    function index($id=1) {
        $this->set('title', '');
        $data = $this->Home->find_by_field('id', $id);
        if (count($data)) $data = $data[0];
        $this->set('data', $data);
        $this->set('title', $data['Home']['seo_page_title']);
        $this->set('meta_keywords', $data['Home']['seo_keywords']);
        $this->set('meta_description', $data['Home']['seo_description']);
        $hpBlocks = array();

        $industry = new Industry();
        $feedIds = array(
          array("id"=>"21", "type"=>"articles"), array("id"=>"22", "type"=>"ft_articles"), array("id"=>"23", "type"=>"videos"),
          array("id"=>"25", "type"=>"resources"), array("id"=>"24", "type"=>"ft_videos"), array("id"=>"51", "type"=>"tweets"));

        if ($data['Home']['event_map']=="F" && $data['Home']['event_map_feed']!="0") {
            array_push($feedIds, array("id"=>$data['Home']['event_map_feed'], "type"=>"custom_feed"));
            array_push($hpBlocks, 'feed');
        } else if ($data['Home']['event_map']=="Y") array_push($hpBlocks, 'map');

        foreach ($feedIds as $o) {
            $ptContent = new Publishthis_Content();
            $ptContent->publishthis_feed_id = $o['id'];
            if ($o['type']=="custom_feed") $ptContent->special_sort = true;
            $hpFeeds[$o['type']] = $ptContent->getFeedContent();
        }

        //$hpBlocks = array('article','article','article','article','article','article','article', 'resource', 'newsletter', 'twitter', 'featured_video', 'article', 'resource', 'twitter', 'video', 'featured_article');
        foreach (array('article', 'resource', 'article', 'twitter', 'featured_video', 'article', 'resource', 'twitter', 'video', 'featured_article') as $x)
            array_push($hpBlocks, $x);

        $blocks = array();
        for($i=0;$i<count($hpBlocks);$i++) {
            $block = array('type'=>'');
            if ($hpBlocks[$i]=='article'||$hpBlocks[$i]=='resource'||$hpBlocks[$i]=='featured_article') {
                if ($hpBlocks[$i]=='article') $row = array_shift($hpFeeds['articles']);
                elseif ($hpBlocks[$i]=='resource') $row = array_shift($hpFeeds['resources']);
                elseif ($hpBlocks[$i]=='featured_article') $row = array_shift($hpFeeds['ft_articles']);
                if (!isset($row['Publishthis_Content'])) continue;
                
                if ($hpBlocks[$i]=='article'||$hpBlocks[$i]=='featured_article') $block['icon'] = 'document';
                elseif ($hpBlocks[$i]=='resource') $block['icon'] = 'open-book';                
                
                $block['ga-a'] = "Home";
                $block['type'] = 'image_link';
                $block['hover'] = 'content/content-back.png';
                
                if ($hpBlocks[$i]=='featured_article') {
                    $block['type'] = 'wide_image_link';
                    $block['hover'] = 'content/content-back_wide.png';
                }
                $block['image'] = $row['Publishthis_Content']['image_url'];                
                $favicon = favicon::getFaviconUrl($row['Publishthis_Content']['url']);
                if ($favicon!==false) {
                    $block['favicon'] = '<img class="favicon" src="'.$favicon.'" alt="">';
                }
                $block['caption'] = $row['Publishthis_Content']['annotation'];
                $block['publisher'] = $row['Publishthis_Content']['publisher'];
                $block['title'] = $row['Publishthis_Content']['title'];
                $block['summary'] = $row['Publishthis_Content']['summary'];
                $block['url'] = $row['Publishthis_Content']['url'];
                $block['Tags'] = $row['Tags'];
                $block['shareId'] = (isset($row['share_id'])?$row['share_id']:"");
                $block['enable_share'] = Authorization::loggedIn();
                
            } else if ($hpBlocks[$i]=='newsletter') {
                $block['type'] = 'newsletter';

            } else if ($hpBlocks[$i]=='newsletter.old') {
                $block['type'] = 'newsletter.old';

            } else if ($hpBlocks[$i]=='twitter') {
                $row = array_shift($hpFeeds['tweets']);
                if (!isset($row['Publishthis_Content'])) continue;
                //print "twitter: ".print_r($row,true)."<br><br>";
                $block['type'] = 'twitter';
                $block['name'] = $row['Publishthis_Content']['user_display_name'];
                $block['username'] = $row['Publishthis_Content']['user_screen_name'];
                $block['time'] = '';
                $block['image'] = 'content/block-11.png';
                $block['tweet'] = $row['Publishthis_Content']['status_text'];
                $block['Tags'] = $row['Tags'];

            } else if ($hpBlocks[$i]=='video'||$hpBlocks[$i]=='featured_video' ) { 
                if ($hpBlocks[$i]=='video') $row = array_shift($hpFeeds['videos']);
                elseif ($hpBlocks[$i]=='featured_video') $row = array_shift($hpFeeds['ft_videos']);
                if (!isset($row['Publishthis_Content'])) continue;
                //print "video: ".print_r($row,true)."<br><br>";
                if ($hpBlocks[$i]=='video') $block['type'] = 'video';
                elseif ($hpBlocks[$i]=='featured_video') $block['type'] = 'wide_video';
                $block['image'] = $row['Publishthis_Content']['image_url'];
                $block['caption'] = $row['Publishthis_Content']['title'];
                $block['url'] = $row['Publishthis_Content']['url'];
                $block['embed'] = base64_encode($row['Publishthis_Content']['embed']);
                $block['video_id'] = "";
                $block['Tags'] = $row['Tags'];
                if (preg_match('/[\\?\\&]v=([^\\?\\&]+)/', $block['url'], $matches)) $block['video_id'] = $matches[1];
            } else if ($hpBlocks[$i]=="map") {
                $block['type'] = "map";

                $event = new Event();
                $events = $event->get_events();
                for($y=0;$y<count($events);$y++) {
                    $topic_links = '';
                    $topics = array();
                    if (trim($events[$y]['Event']['topics'])!="") $topics = explode(';', $events[$y]['Event']['topics']);
                    for($z=0;$z<count($topics);$z++) {
                        $industry = new Industry();
                        $iobj = $industry->find_by_field('id', $topics[$z]);
                        $url = $industry->get_url($topics[$z]);
                        if (count($iobj)) {
                            $topic_links .= ($z>0?',&nbsp;':'').'<a target="_blank" href="'.$url.'">'.$iobj[0]['Industry']['title'].'</a>';
                        }
                    }
                    if (trim($events[$y]['Event']['write_in_topic'])!="") $topic_links .= ($z>0?',&nbsp;':'').(trim($events[$y]['Event']['write_in_topic_link'])!=''?'<a href="'.$events[$y]['Event']['write_in_topic_link'].'" target="_blank">'.$events[$y]['Event']['write_in_topic'].'</a>':$events[$y]['Event']['write_in_topic']);
                    $events[$y]['Event']['topics'] = $topic_links;
                }
                $block['events'] = $events;
                $this->set('events', $events);

            } else if ($hpBlocks[$i]=="feed") {
                $block['type'] = "feed";
                $block['feed'] = $hpFeeds['custom_feed'];
            }
            
            if ($block['type']!="") $blocks[] = $block;
        }

        $this->set('blocks', $blocks);

        $industry = new Industry();
        $industry->orderBy('place_order');
        $industry->where('status', 2);
        $this->set('industries', $industry->get_industries());

    }
    
    function view($id=null) {
        $data = array();
        $this->admin(true);
        $this->set('title', 'Home Page');

        if ($id!==null) {
            $this->Home->id = $id;
            $data = $this->Home->search();
            if (isset($data['Home']['event_map_feed'])) {
                $feed = new Publishthis_Feed();
                $feed->id = $data['Home']['event_map_feed'];
                $feedData = $feed->search();
                if (isset($feedData['Publishthis_Feed'])) {
                    $data['Home']['event_map_feed_id'] = $feedData['Publishthis_Feed']['feed_id'];
                    $data['Home']['event_map_feed_section'] = $feedData['Publishthis_Feed']['section_id'];
                }
            }
        }        
        $this->set('data', $data);

        // get event list
        $this->set('active_events', Event::html_admin_list(new HTML()));                
        
        // get industry list for sidebar
        $industry = new Industry();
        $industry->orderBy('place_order');
        $this->set('industries', $industry->get_industries());
        
    }
        
    function save() {
        if (isset($_POST['Do']) && $_POST['Do']=="Submit") {
            $this->render = 0;

            $ptf = new Publishthis_Feed();
            if ($_POST['event_map']=="F") {
                if (isset($_POST['event_map_feed']) && $_POST['event_map_feed']!="" && $_POST['event_map_feed']!="0") $ptf->id = $_POST['event_map_feed'];
                $ptf->industry_id = 0;
                $ptf->feed_type = 'C';
                $ptf->feed_id = $_POST['event_map_feed_id'];
                $ptf->section_id = $_POST['event_map_feed_section'];
                $_POST['event_map_feed'] = $ptf->save();
            } else {
                if (isset($_POST['event_map_feed']) && $_POST['event_map_feed']!="") {
                    $ptf->id = $_POST['event_map_feed'];
                    $ptf->delete();
                    $_POST['event_map_feed'] = 0;
                }
            }

            $home = new Home();
            if (isset($_POST['id']) && is_numeric($_POST['id']) && $_POST['id']>0) $home->id = $_POST['id'];
            $home->intro_paragraph = $_POST['intro_paragraph'];
            $home->seo_page_title = $_POST['seo_page_title'];
            $home->seo_keywords = $_POST['seo_keywords'];
            $home->seo_description = $_POST['seo_description'];
            $home->event_map = $_POST['event_map'];
            $home->event_map_feed = $_POST['event_map_feed'];
            $home->unknown_field = $_POST['unknown_field'];
            $home->cta_link_text = $_POST['cta_link_text'];
            $home->cta_link = $_POST['cta_link'];
            $home->facebook_url = $_POST['facebook_url'];
            $home->linkedin_url = $_POST['linkedin_url'];
            $home->twitter_url = $_POST['twitter_url'];
            $home->googleplus_url = $_POST['googleplus_url'];
            $home->event_map_feed = (isset($_POST['event_map_feed'])?$_POST['event_map_feed']:0);

            $id = $home->save();

            if ($id) $_SESSION['message'] = 'Home page saved successfully.';                    
            header("Location: /homes/view/".$id);
            exit;
        }
    }
    
    function contact() {
        $this->render = 0;
        $validator = new FormValidator();
        $validator->addFields(array(
            "first_name" => array("type"=>"text", "required"=>true),
            "last_name" => array("type"=>"text", "required"=>true),
            "email_address" => array("type"=>"email", "required"=>true)
            //"what_matters" => array(),
        ));
        $out = array("status"=>false);
        if (!$validator->validate($_POST)) {
            $out['fields'] = $validator->getFailedFields();
        } else {
            $out['status']=true;
        }
        echo json_encode($out);
        exit;
    }
}

class HomesValidator extends FormValidator {

}