<?php

class HomesController extends Controller {
    function index($id=1) {
        $this->set('title', '');
        $data = $this->Home->find_by_field('id', $id);
        if (count($data)) $data = $data[0];
        $this->set('data', $data);
        $this->set('title', $data['Home']['seo_page_title']);
        $this->set('meta_keywords', $data['Home']['seo_keywords']);
        $this->set('meta_description', $data['Home']['seo_description']);
        
                
        foreach (array("21"=>"articles", "22"=>"ft_articles", "23"=>"videos", "25"=>"resources", "24"=>"ft_videos", "51"=>"tweets") as $fid=>$ftype) {
            $ptContent = new Publishthis_Content();
            $ptContent->orderBy('publish_date', 'DESC');
            $ptContent->where('publishthis_feed_id', $fid);            
            $hpFeeds[$ftype] = $ptContent->search();
        }
        
        $hpBlocks = array('article', 'resource', 'newsletter', 'twitter', 'featured_video', 'article', 'resource', 'twitter', 'video', 'featured_article');
        $blocks = array();
        for($i=0;$i<count($hpBlocks);$i++) {
            $block = array('type'=>'');
            if ($hpBlocks[$i]=='article'||$hpBlocks[$i]=='resource'||$hpBlocks[$i]=='featured_article') {
                if ($hpBlocks[$i]=='article') $row = array_shift($hpFeeds['articles']);
                elseif ($hpBlocks[$i]=='resource') $row = array_shift($hpFeeds['resources']);
                elseif ($hpBlocks[$i]=='featured_article') $row = array_shift($hpFeeds['ft_articles']);
                
                if (!isset($row['Publishthis_Content'])) continue;
                
                if ($hpBlocks[$i]=='article'||$hpBlocks[$i]=='featured_article') $block['icon'] = 'document';
                elseif ($hpBlocks[$i]=='resource') $block['icon'] = 'open-book';                
                
                $block['ga-a'] = "Home";
                $block['type'] = 'image_link';
                $block['hover'] = 'content/content-back.png';
                
                if ($hpBlocks[$i]=='featured_article') {
                    $block['type'] = 'wide_image_link';
                    $block['hover'] = 'content/content-back_wide.png';
                }
                $block['image'] = $row['Publishthis_Content']['image_url'];                
                $favicon = favicon::getFaviconUrl($row['Publishthis_Content']['url']);
                if ($favicon!==false) {
                    $block['favicon'] = '<img class="favicon" src="'.$favicon.'" alt="">';
                }
                $block['caption'] = $row['Publishthis_Content']['annotation'];
                $block['publisher'] = $row['Publishthis_Content']['publisher'];
                $block['title'] = $row['Publishthis_Content']['title'];
                $block['summary'] = $row['Publishthis_Content']['summary'];
                $block['url'] = $row['Publishthis_Content']['url'];
                
            } else if ($hpBlocks[$i]=='newsletter') {
                $block['type'] = 'newsletter';
                
            } else if ($hpBlocks[$i]=='newsletter.old') {
                $block['type'] = 'newsletter.old';
                
            } else if ($hpBlocks[$i]=='twitter') {
                $row = array_shift($hpFeeds['tweets']);
                if (!isset($row['Publishthis_Content'])) continue;
                //print "twitter: ".print_r($row,true)."<br><br>";
                $block['type'] = 'twitter';
                $block['name'] = $row['Publishthis_Content']['user_display_name'];
                $block['username'] = $row['Publishthis_Content']['user_screen_name'];
                $block['time'] = '';
                $block['image'] = 'content/block-11.png';
                $block['tweet'] = $row['Publishthis_Content']['status_text'];
                
            } else if ($hpBlocks[$i]=='featured_article') {
                $row = array_shift($hpFeeds['ft_articles']);
                if (!isset($row['Publishthis_Content'])) continue;
                //print "featured article: ".print_r($row,true)."<br><br>";                
                $block['type'] = 'wide_image_link';
                $block['image'] = $row['Publishthis_Content']['image_url'];
                $block['hover'] = 'content/block-2.png';
                $block['icon'] = 'document';
                $block['title'] = $row['Publishthis_Content']['title'];
                
            } else if ($hpBlocks[$i]=='video'||$hpBlocks[$i]=='featured_video' ) { 
                if ($hpBlocks[$i]=='video') $row = array_shift($hpFeeds['videos']);
                elseif ($hpBlocks[$i]=='featured_video') $row = array_shift($hpFeeds['ft_videos']);
                if (!isset($row['Publishthis_Content'])) continue;
                //print "video: ".print_r($row,true)."<br><br>";
                if ($hpBlocks[$i]=='video') $block['type'] = 'video';
                elseif ($hpBlocks[$i]=='featured_video') $block['type'] = 'wide_video';
                $block['image'] = $row['Publishthis_Content']['image_url'];
                $block['caption'] = $row['Publishthis_Content']['title'];
                $block['url'] = $row['Publishthis_Content']['url'];
                $block['embed'] = base64_encode($row['Publishthis_Content']['embed']);
                $block['video_id'] = "";
                if (preg_match('/[\\?\\&]v=([^\\?\\&]+)/', $block['url'], $matches)) $block['video_id'] = $matches[1];
            }
            
            if ($block['type']!="") $blocks[] = $block;
        }        
        $this->set('blocks', $blocks);

        $industry = new Industry();
        $industry->orderBy('place_order');
        $industry->where('status', 2);
        $this->set('industries', $industry->get_industries());

        $event = new Event();
        $events = $event->get_events();
        for($i=0;$i<count($events);$i++) {
            $topic_links = '';
            $topics = array();
            if (trim($events[$i]['Event']['topics'])!="") $topics = explode(';', $events[$i]['Event']['topics']);
            for($z=0;$z<count($topics);$z++) {
                $industry = new Industry();
                $iobj = $industry->find_by_field('id', $topics[$z]);
                $url = $industry->get_url($topics[$z]);
                if (count($iobj)) {                    
                    $topic_links .= ($z>0?',&nbsp;':'').'<a target="_blank" href="'.$url.'">'.$iobj[0]['Industry']['title'].'</a>';                
                }
            }
            if (trim($events[$i]['Event']['write_in_topic'])!="") $topic_links .= ($z>0?',&nbsp;':'').(trim($events[$i]['Event']['write_in_topic_link'])!=''?'<a href="'.$events[$i]['Event']['write_in_topic_link'].'" target="_blank">'.$events[$i]['Event']['write_in_topic'].'</a>':$events[$i]['Event']['write_in_topic']);
            $events[$i]['Event']['topics'] = $topic_links;
        }
        $this->set('events', $events);
    }
    
    function view($id=null) {
        $data = array();
        $this->admin(true);
        $this->set('title', 'Home Page');

        if ($id!==null) {
            $this->Home->id = $id;
            $data = $this->Home->search();            
        }        
        $this->set('data', $data);

        // get event list
        $this->set('active_events', Event::html_admin_list(new HTML()));                
        
        // get industry list for sidebar
        $industry = new Industry();
        $industry->orderBy('place_order');
        $this->set('industries', $industry->get_industries());
        
    }
        
    function save() {
        if (isset($_POST['Do']) && $_POST['Do']=="Submit") {
            $this->render = 0;

            $home = new Home();
            if (isset($_POST['id']) && is_numeric($_POST['id']) && $_POST['id']>0) $home->id = $_POST['id'];
            $home->intro_paragraph = $_POST['intro_paragraph'];
            $home->seo_page_title = $_POST['seo_page_title'];
            $home->seo_keywords = $_POST['seo_keywords'];
            $home->seo_description = $_POST['seo_description'];
            $home->event_map = $_POST['event_map'];
            $home->unknown_field = $_POST['unknown_field'];
            $home->cta_link_text = $_POST['cta_link_text'];
            $home->cta_link = $_POST['cta_link'];
            $home->facebook_url = $_POST['facebook_url'];
            $home->linkedin_url = $_POST['linkedin_url'];
            $home->twitter_url = $_POST['twitter_url'];
            $home->googleplus_url = $_POST['googleplus_url'];

            $id = $home->save();

            if ($id) $_SESSION['message'] = 'Home page saved successfully.';                    
            header("Location: /homes/view/".$id);
            exit;
        }            
    }  
    
    function contact() {
        $this->render = 0;
        $validator = new FormValidator();
        $validator->addFields(array(
            "first_name" => array("type"=>"text", "required"=>true),
            "last_name" => array("type"=>"text", "required"=>true),
            "email_address" => array("type"=>"email", "required"=>true)
            //"what_matters" => array(),
        ));
        $out = array("status"=>false);
        if (!$validator->validate($_POST)) {
            $out['fields'] = $validator->getFailedFields();
        } else {
            $out['status']=true;
        }
        echo json_encode($out);
        exit;
    }
}

class HomesValidator extends FormValidator {

}