<?php

class IndustriesController extends Controller {
    function viewall() {
        $this->admin(true);
        $this->set('todo',$this->Industry->search());
    }
    
    function index($id=null,$debug=false) {
        $this->set('debug', $debug);
        $articleBlocks = $podBlocks = $videoBlocks = $blogBlocks = $topBlocks = $bgBlock = array();
                
        $this->set('leadformix_industry_id', (isset($this->Industry->leadformix_industry_map[$id])?$this->Industry->leadformix_industry_map[$id]:""));
        
        $this->Industry->id = $id;
        $selIndustry = $this->Industry->search();
        if (!isset($selIndustry['Industry'])) {
            header("Location: ".SITE_URL); 
            exit;
        }
        $this->set('industry', $selIndustry);
        $this->set('title', $selIndustry['Industry']['seo_title']);
        $this->set('meta_keywords', $selIndustry['Industry']['seo_keywords']);
        $this->set('meta_description', $selIndustry['Industry']['seo_description']);
        

        $industry = new Industry();
        $this->set('statuses', $industry->get_statuses());
        $this->set('industries', $industry->get_active_industries());
        
        $ptContent = new Publishthis_Content();
        $feeds = $ptContent->getIndustryFeeds($id);

        $topBlocks = array(
            array('type'=>'secondary_header', 'industry'=>$selIndustry['Industry']['title'], 'data'=>(count($feeds[1006])?$feeds[1006][0]:array())),
            array('type'=>'secondary_infographic', 'industry'=>$selIndustry['Industry']['title'], 'data'=>(count($feeds[1249])?$feeds[1249]:array())),
            array('type'=>'secondary_carousel', 'industry'=>$selIndustry['Industry']['title'], 'data'=>(count($feeds[1005])?$feeds[1005]:array())),            
        );

        if (count($feeds[1314])) $bgBlock = $feeds[1314];
        if (count($feeds[1003])) $articleBlocks = $feeds[1003];
        if (count($feeds[1004])) $videoBlocks = $feeds[1004];
        if (count($feeds[1250])) $podBlocks = $feeds[1250];
        if (count($feeds[0])) $blogBlocks = $feeds[0];

        for($i=0;$i<count($videoBlocks);$i++) {
            $videoBlocks[$i]['Publishthis_Content']['video_id'] = "";
            if (preg_match('/[\\?\\&]v=([^\\?\\&]+)/', $videoBlocks[$i]['Publishthis_Content']['url'], $matches)) $videoBlocks[$i]['Publishthis_Content']['video_id'] = $matches[1];
        }
        
        $this->set('bgBlock', $bgBlock);
        $this->set('topBlocks', $topBlocks);
        $this->set('articleBlocks', $articleBlocks);
        $this->set('videoBlocks', $videoBlocks);
        $this->set('podBlocks', $podBlocks);
        $this->set('blogBlocks', $blogBlocks);        
        
        $home = new Home();
        $data = $home->find_by_field('id', '1');
        if (count($data)) $data = $data[0];
        $this->set('data', $data);
        
    }
    
    function view($id=null) {
        $data = array();
        $this->admin(true);
        $this->set('title', 'Industry');
        
        $industry = new Industry();
        $this->set('statuses', $industry->get_statuses());        
        $industry->orderBy('place_order');
        $this->set('industries', $industry->get_industries());
        
        if ($id!==null) {
            $this->Industry->id = $id;
            $data = $this->Industry->search();            
        }   
        if (isset($_POST['Do']) && $_POST['Do']=="Submit") $data = array('Industry'=>$_POST);
        $this->set('data', $data);
    }
    
    function save() {
        if (isset($_POST['Do']) && $_POST['Do']=="Submit") {
            if (isset($_POST['id']) && is_numeric($_POST['id']) && $_POST['id']>0) {
                $this->Industry->id = $_POST['id'];
            } else {
                $this->Industry->place_order = $this->Industry->maxPlace();
            }
                
            $validator = new IndustriesValidator();
            $validator->addFields($this->Industry->validate);
            if ($validator->validate($_POST, $this->Industry->id)) {
                $this->render = 0;
                
                $this->Industry->status = $_POST['status'];
                $this->Industry->title = $_POST['title'];
                $this->Industry->slug = $_POST['slug'];
                $this->Industry->feed_id = $_POST['feed_id'];
                $this->Industry->essentials_box_title = $_POST['essentials_box_title'];
                $this->Industry->seo_title = $_POST['seo_title'];
                $this->Industry->seo_keywords = $_POST['seo_keywords'];
                $this->Industry->seo_description = $_POST['seo_description'];
                $this->Industry->left_column_headline = $_POST['left_column_headline'];
                $this->Industry->right_column_headline = $_POST['right_column_headline'];
                $this->Industry->left_column_body = $_POST['left_column_body'];
                $this->Industry->right_column_body = $_POST['right_column_body'];
                $this->Industry->right_column_cta_text = $_POST['right_column_cta_text'];
                $this->Industry->right_column_link_text = $_POST['right_column_link_text'];
                $this->Industry->right_column_link = $_POST['right_column_link'];
                $this->Industry->facebook_url = $_POST['facebook_url'];
                $this->Industry->linkedin_url = $_POST['linkedin_url'];
                $this->Industry->twitter_url = $_POST['twitter_url'];
                $this->Industry->googleplus_url = $_POST['googleplus_url'];
                
                $id = $this->Industry->save();
                
                if ($id) {
                    $_SESSION['message'] = 'Secondary page saved successfully.';
                    if ($_POST['feed_id']!=false) {
                        $feeds = new PublishThis_Feed();
                        $feeds->update_industry_feeds($id, $_POST['feed_id']);               
                    }
                }

                header("Location: /industries/view/".$id);
                exit;
            } else {
                $_SESSION['message'] = $validator->getErrors();
                changeHook('industries/view'.($this->Industry->id!=false?'/'.$this->Industry->id:''));
            }
        }
    }
    
    function moveup($id) {
        $this->render = 0;
        $this->Industry->id = $id;
        $res = $this->Industry->move(-1);
        
        header("Location: /industries/view/".$id);
    }

    function movedown($id){
        $this->render = 0;
        $this->Industry->id = $id;
        $res = $this->Industry->move(1);
        
        header("Location: /industries/view/".$id);
    }

}

class IndustriesValidator extends FormValidator {
    function __construct() {
        $this->addMethod('slug', 'validateSLUG');
    }
    
    function validateSLUG($data, $required) {
        $out = array("status"=>true, 'errors'=>'');
        
        /* Ensure SLUG is unique */
        if (trim($data)!="") { 
            $i = new Industry();
            $f = $i->find_by_slug($data);
            for($i=0;$i<count($f);$i++) if ($f[$i]['Industry']['id']!=$this->_currentId) {
                $out['status'] = false;
                $out['errors'] = 'SLUG already in use';
                return $out;
            }
        
            /* Ensure SLUG matches URL requirements */
            if (!preg_match('/^[a-zA-z0-9_\-\.]+$/', $data)) {
                $out['status'] = false;
                $out['errors'] = 'Invalid characters found in SLUG';
                return $out;
            }
        }
        
        return $out;
    }
}