<?php

class PublishThis_FeedsController extends Controller {


    // PublishThis PUSH API Implementation
    function push() {
      $this->render = 0;

      $in = file_get_contents("php://input");
      $cmd = json_decode($in);

      if (!isset($cmd->action)) return false;

      $out = array('success'=>true, 'errorMessage'=>null);
      switch ($cmd->action) {
        case "verify":
          // Dummy function for PublishThis verification of API - returns success
          break;

        case "getAuthors":
          $out['authors'] = array(
            /*array(id=>1, name=>'name')*/
          );
          break;

        case "getCategories":
          $out['categories'] = array();
          $industry = new Industry();
          foreach ($industry->get_industries() as $i)
            $out['categories'][] = array(id => $i['Industry']['id'], name => $i['Industry']['title']);
          break;


        case "publish":
          $this->Publishthis_feed->where('feed_id', $cmd->feedId);
          $this->Publishthis_feed->where('section_id', $cmd->templateId);
          $feeds = $this->Publishthis_feed->search();

          if (count($feeds))
            foreach ($feeds as $feed) {
              $ptc = new PublishThis_Content();
              $ptc->PublishThis_Feed = $feed;
              $ptc->import_publishthis_feed();
            }

          break;
      }

      header('Content-Type: application/json');
      echo json_encode($out);
      exit;
    }


    // Time-based import of non-curated feeds, such as: automated (twitter/blogs)
    function import_contents($debug=false) {
      $this->render = 0;

      //$this->Publishthis_feed->where("feed_type", "C", "!=");
      $result = $this->Publishthis_feed->search();

      if (count($result)) {
        $ptc = new PublishThis_Content();
        $ptc->debug = $debug;
        for($i=0;$i<count($result);$i++) {
            $ptc->PublishThis_Feed = $result[$i];
            $ptc->import_publishthis_feed();
        }
      }
    }
}