<?php
 
class Industry extends Model {
    protected $_place_field = 'place_order';
    private $_statuses = array(
        "1"=>"Unpublished",
        "2"=>"Published"
    );
    private $STATUS_PUBLISHED = 2;
    private $STATUS_UNPUBLISHED = 1;
    
    public $validate = array(
        'slug' => array('type'=>'slug', 'label'=>'SLUG'),
        'title' => array('type'=>'text', 'required'=>true, 'label'=>'Conversations on'),
        'feed_id' => array('type'=>'text', 'label'=>'Feed ID')
    );
    
    public $leadformix_industry_map = array(
        "3" => "1",
        "6" => "2",
        "9" => "3",
        "5" => "4",
        "11" => "5"        
    );
    
    function get_statuses() {
        return $this->_statuses;
    }

    function get_industries() {
        return $this->search();
    }
    
    function get_active_industries() {
        $this->orderBy('place_order');
        return $this->find_by_field('status', $this->STATUS_PUBLISHED);
    }
    
    function find_by_slug($url) {
        if (preg_match('/^(.+?)\/+$/', $url, $matches)) $url = $matches[1];
        return $this->find_by_field('slug', $url);
    }
    
    function get_url($id) {
        $url = "";
        $ret = $this->find_by_field('id', $id);
        if (count($ret)) {
            if (trim($ret[0]['Industry']['slug'])!="") $url = '/'.$ret[0]['Industry']['slug'];
            else $url = '/industries/view/'.$id;
        }
        return $url;
    }
}