<?php

class Industry_Newsletter extends Model {

    protected $_industry;
    protected $_feeds;

    static public $templates = array(
        'article' => <<<EOF
<table cellspacing="0" cellpadding="0" border="0" class="InlinePhoto" style="text-align: right !important;">
  <tr>
    <td width="100%" style="text-align: left !important; border-collapse: collapse;" valign="top" align="left">
      <table align="left" width="125">
        <tr>
          <td style="border-collapse: collapse;padding-top:11px;"><img src="{IMAGE}" alt="" width="100" height="100" border="0" align="left" style="height: auto; line-height: 100%; outline: none; text-decoration: none; border: 0px none;" ></td>
        </tr>
      </table>
      <h4 style="line-height: 120%;font-size: 14px; font-family: Arial, Helvetica, sans-serif; color: #333333 !important; font-weight: bold; text-align: left; margin: 10px 0 0;" align="left"><a href="{URL}" target="_blank" style="color: #0066B3; font-weight: normal; text-decoration: none;">{TITLE}</a></h4>
      <p style="line-height: 120%;font-weight: normal; font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555; text-align: left; margin: .5em 0;" align="left">
      {SUMMARY}<br><br></p>
    </td>
  </tr>
</table>
EOF
    ,

    'blog' => <<<EOF
<table cellspacing="0" cellpadding="0" border="0" class="InlinePhoto" style="text-align: right !important;">
  <tr>
    <td width="100%" style="text-align: left !important; border-collapse: collapse;" valign="top" align="left">
      <h4 style="font-size: 14px; font-family: Arial, Helvetica, sans-serif; color: #333333 !important; font-weight: bold; line-height: 120% !important; text-align: left; margin: 10px 0 0;" align="left"><a href="{URL}" target="_blank" style="color: #0066B3; font-weight: normal; text-decoration: none;">{TITLE}</a></h4>
      <p style="font-weight: normal; font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555; line-height: 120%; text-align: left; margin: .5em 0;" align="left">{SUMMARY}</p>
    </td>
  </tr>
</table>
EOF
    ,

    'body' => <<<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" >
    <meta name="format-detection" content="telephone=no" >
    <meta name="viewport" content="initial-scale=1.0" >
    <title>SAP Newsletter Email</title>
  </head>
  <body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" style="-webkit-font-smoothing: antialiased; width: 100% !important; max-width: 600px; -webkit-text-size-adjust: none; margin: 0 auto; padding-top:0;padding-bottom:0;padding-left:0;padding-right:0;">
<center>
<div style="width:100%;max-width:600px;margin-top:0;margin-bottom:0;margin-right:auto;margin-left:auto;padding-top:0;padding-bottom:0;padding-left:0;padding-right:0;">
<!--[if (gte mso 9)|IE]>
  <table width="600" align="center" cellpadding="0" cellspacing="0" border="0">
    <tr>
      <td>
<![endif]-->

<!--header-->
<table cellspacing="0" border="0" cellpadding="0" width="95%" align="center"><tr><td valign="top" width="100%" style="border-collapse: collapse;"><!--top links-->
			<table cellspacing="0" border="0" cellpadding="0" width="100%"><tr><td style="text-align:left; font-size: 11px; font-family: Arial, Helvetica, sans-serif; color: #555555; border-collapse: collapse; margin: 0px;">To ensure you continue to receive SAP related information properly please add <a href="https://www.sap.com/contactsap" style="text-decoration: none !important; font-size: 11px; font-family: Arial, Helvetica, sans-serif; color: #0066B3;">sap@mailsap.com</a> to your address book or safe senders list.</td>
				</tr></table><!--/top links--></td>
	</tr><tr><td height="18" width="100%" style="border-collapse: collapse;"><!-- anchor for back to top --></td>
	</tr><tr><td valign="top" width="100%" style="border-collapse: collapse;"><!-- logo, tagline and contact-->
      <table width="100%" cellspacing="0" cellpadding="0" border="0"><tr><td align="left" width="70" style="font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #666666; font-weight: bold; border-collapse: collapse; margin: 0px;"><img src="http://www.sap.com/global/ui/images/logos/sap-logo.png" alt="SAP" width="66" height="33" style="height: auto; line-height: 100%; outline: none; text-decoration: none; border: 0px none;" ></td>
          <td width="15" class="Tagline" style="color: #666666; font-size: 12px; font-family: Arial, Helvetica, sans-serif; font-weight: bold; border-collapse: collapse; line-height: 120%; text-align: left; margin: 0px;" align="left"> </td>
          <td align="right" class="ContactUtility" style="color: #666666; font-size: 14px; font-family: Arial, Helvetica, sans-serif; font-weight: normal; line-height: 120%; text-align: right; border-collapse: collapse; margin: 0px;">Conversations on the Future of Business</td>
        </tr></table><!-- /logo, tagline and contact--></td>
	</tr><tr><td height="15" width="100%" style="border-collapse: collapse;"><!-- spacer --></td>
	</tr><tr><td height="9" bgcolor="#F0AB00" width="100%" style="border-collapse: collapse;"><!-- orange bar --></td>
	</tr><tr><td height="30" width="100%" style="border-collapse: collapse;"><!-- spacer --></td>
	</tr></table><!--/header--><!--intro--><table cellspacing="0" border="0" cellpadding="0" width="95%" align="center"><tr><td valign="top" width="100%" style="border-collapse: collapse;">
        <table cellspacing="0" border="0" cellpadding="0" width="100%" style="border-collapse: collapse;" bordercolor="#111111"><tr><td align="left" valign="top" style="border-collapse: collapse;">
            <table class="headerTable" cellspacing="0" cellpadding="0" border="0" align="left" style="width: 100%;"><tr><td style="border-collapse: collapse;">
                  <h1 style="color: #555555; font-size: 12px; font-family: Arial, Helvetica, sans-serif; font-weight: normal; display: block; line-height: 100% !important; text-align: left; margin: 0 0 5px;" align="left">{MON_D_YYYY}</h1>
                  <h2 style="color: #F0AB00; font-size: 22px; font-family: Arial, Helvetica, sans-serif; font-weight: bold; display: block; line-height: 100% !important; text-align: left; margin: 0 0 5px;" align="left">{HEADLINE}</h2>
                  <h3 style="color: #555555; font-size: 14px; font-family: Arial, Helvetica, sans-serif; font-weight: normal; display: block; line-height: 120% !important; text-align: left; margin: 0 0 0px;" align="left">{INTRO_P}<br ><br ></h3>
                </td>
				      </tr></table></td>
				</tr></table></td>
	</tr></table><!--/intro--><table cellspacing="0" border="0" cellpadding="0" width="95%" align="center"><tr><td valign="top" width="100%" style="border-collapse: collapse;"><!--Article 1-->

		  <table border="0" align="left" cellpadding="0" cellspacing="0" width="68.1%" class="BodyContent" style="color: #555555; font-family: Arial, Helvetica, sans-serif; font-size: 12px; line-height: 120%; text-align: left; width: 68.1%; padding-right: 35px;"><tr><td valign="top" style="font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555 margin: 0px; border-collapse: collapse;">
		        <!-- *** inline photo *** -->
		        <table cellspacing="0" border="0" cellpadding="0" bgcolor="#ffffff" style="margin-top: 8px; border-collapse: collapse;" bordercolor="#111111"><tr><td align="left" valign="middle" style="border-collapse: collapse;"><strong><span style="font-family: Arial, Helvetica, sans-serif; font-size: 14px; color: #000000;">Buzzworthy: What we're reading</span></strong></td>
	              </tr></table><hr style="background-color: #CCCCCC; color: #CCCCCC; height: 1px; border: none #cccccc;" >
                {SPOTLIGHT_ARTICLE}
                </td>
	      </tr><tr><td width="100%" valign="top" style="font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555 margin: 0px; border-collapse: collapse;">
            {ARTICLE_1}
		        </td>
	      </tr><tr><td width="100%" valign="top" style="font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555 margin: 0px; border-collapse: collapse;">
            {ARTICLE_2}
               <table cellspacing="0" cellpadding="0" border="0" class="InlinePhoto" style="text-align: right !important;"><tr>
                 <td width="100%" style="text-align: left !important; border-collapse: collapse;" valign="top" align="left"><table border="0" cellpadding="0" cellspacing="0" style="color:#FFFFFF;font-family:Arial,Helvetica,sans-serif;font-size:11px;line-height:100%;text-align:right;">
                   <tr>
                     <td width="15" height="30"><img src="http://www.sap.com/global/ui/images/emails/email-btn-cta-orangeleft.png" width="15" height="30" alt="" border="0" style="margin:0; padding:0; display:block; height:30px"></td>
                     <td height="30" align="center" bgcolor="#F0AB00"><a href="{BUTTON_LINK}" target="_blank" style=" text-decoration:none; font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #FFFFFF; font-weight:bold;">{BUTTON_TEXT}</a></td>
                     <td width="30" height="30"><img src="http://www.sap.com/global/ui/images/emails/email-btn-cta-orangeright.png" width="30" height="30" alt="" border="0" style="margin:0px 0px 0px 0px; padding:0px 0px 0px 0px; display:block; height:30px" ></td>
                   </tr>
                 </table></td>
              </tr></table>
               <br></td>
        </tr><tr>
          <td width="100%" valign="top" style="font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555 margin: 0px; border-collapse: collapse;">	        <table cellspacing="0" border="0" cellpadding="0" bgcolor="#ffffff" style="margin-top: 8px; border-collapse: collapse;" bordercolor="#111111"><tr><td align="left" valign="middle" style="border-collapse: collapse;"><strong><span style="font-family: Arial, Helvetica, sans-serif; font-size: 14px; color: #000000;">Fresh Perspectives</span></strong><br>
<span style="font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #555555;"><em>from the SAP Business Innovation Blog</em></span></td>
	              </tr></table><hr style="background-color: #CCCCCC; color: #CCCCCC; height: 1px; border: none #cccccc;" ><!-- *** Bulleted list *** --><!--cta--><!--/cta--></td>
        </tr><tr><td width="100%" valign="top" style="font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555 margin: 0px; border-collapse: collapse;">
              {BLOGS}
              <table cellspacing="0" cellpadding="0" border="0" class="InlinePhoto" style="text-align: right !important;"><tr>
                <td width="100%" style="text-align: left !important; border-collapse: collapse;" valign="top" align="left"><h4 style="font-size: 14px; font-family: Arial, Helvetica, sans-serif; color: #333333 !important; font-weight: bold; line-height: 120% !important; text-align: left; margin: 10px 0 0;" align="left">&nbsp;</h4></td>
              </tr></table><!-- *** Bulleted list *** --><!--cta--><!--/cta--></td>
        </tr></table><table width="175" border="0" cellpadding="0" cellspacing="0" class="SideModule" style="text-align: left; border-collapse: collapse;"><tr><td width="100%">
            <table width="175" align="left" border="0" cellspacing="0" cellpadding="0" class="SideModuleTableLeft">
              <tr>
                <td style="border-collapse: collapse;padding-top:8px;padding-bottom:20px;"><a href="{SIDEBAR_IMAGE_LINK}" target="_blank">{SIDEBAR_IMAGE}</a></td>
              </tr>
            </table>
            <!--[if lte mso 11]>
            <br><br><br><br><br><br><br><br><br><br>
            <![endif]-->
            <table width="175" align="right" border="0" cellspacing="0" cellpadding="0" class="SideModuleTableRight" style="border-collapse: collapse;">
              <tr><td>
                <table width="100%" border="0" cellspacing="0" cellpadding="0" style="border-collapse:collapse;">
                  <tr><td height="4" bgcolor="#000000" width="100%" style="font-size:4px;line-height:4px;">&nbsp;<!-- black bar --></td></tr>
                </table>
                <table width="100%" border="0" cellspacing="0" cellpadding="0" style="border-collapse:collapse;">
                  <tr>
                    <td width="100%" bgcolor="#F0F0F0" class="SideModuleGrayBground" style="background-color:#F0F0F0;border-collapse:collapse;">
                      <table border="0" cellspacing="0" cellpadding="0" style="border-collapse:collapse;padding-bottom:10px;">
                        <tr>
                          <td style="padding-top:10px;padding-bottom:10px;padding-left:10px;padding-right:10px;">
                            <h4 style="line-height:120%;font-size: 14px; font-family: Arial, Helvetica, sans-serif; color: #333333; font-weight: bold; text-align: left; margin: 10px 0 0;" align="left">{SIDEBAR_HEADING}</h4>
                            <!-- Need style within p becuase Gmail only allows inline style and the H tag removes it -->
                            <p style="line-height:120%;font-weight: normal; font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #555555; margin: .5em 0;">
                              {SIDEBAR_P}
                            </p>
                            <p style="margin: .5em 0;">
                              <a href="{SIDEBAR_BTN_LINK}" style="line-height:120%;text-decoration: none; font-size: 12px; font-family: Arial, Helvetica, sans-serif; color: #0066B3; font-weight: normal;">{SIDEBAR_BTN_TEXT}</a>
                            </p>
                          </td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table></td>
              </tr></table></td>
        </tr></table></td>
  </tr></table><!-- Footer --><center>
<table width="95%" border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;" bordercolor="#111111" align="center"><tr><td style="border-collapse: collapse;">
      <table bgcolor="#000000" width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="Footer" style="color: #FFFFFF; font-family: Arial, Helvetica, sans-serif; font-size: 11px; line-height: 100%; text-align: right;"><tr><td height="25" align="right" style="font-weight: normal; font-size: 11px; font-family: Arial, Helvetica, sans-serif; color: #FFFFFF; border-collapse: collapse;"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" style="font-size: 8pt; text-decoration: none; line-height: 10pt;"><a href="https://www.sap.com/usa/profile/unsubscribe.epx?PID=10386&amp;PFID=12894" target="_blank" style="color: #FFFFFF; text-decoration: none; font-weight: normal;">Unsubscribe</a>  |  <a href="http://www.sap.com/contactsap/index.epx" target="_blank" style="color: #FFFFFF; text-decoration: none; font-weight: normal;">Contact SAP</a>  |  <a href="http://www.sap.com/company/legal/copyright/index.epx" target="_blank" style="color: #FFFFFF; text-decoration: none; font-weight: normal;">Copyright/Trademark</a>  |  <a href="http://www.sap.com/company/legal/privacy.epx" target="_blank" style="color: #FFF; text-decoration: none; font-weight: normal;">Privacy</a>  |  <a href="http://www.sap.com/company/legal/impressum.epx" target="_blank" style="color: #FFFFFF; text-decoration: none; font-weight: normal;">Impressum</a></font></td>
					<td width="10" style="border-collapse: collapse;"></td>
				</tr></table></td>
	</tr><tr><td align="left" valign="top" style="border-collapse: collapse;">
      <p style="font-weight: normal; font-size: 7pt; font-family: Arial, Helvetica, sans-serif; color: #9B9B9B; text-decoration: none; margin: .5em 0;">SAP Americas, 3999 West Chester Pike, Newton Square, PA 19073<br ><br >
      This promotional e-mail provides information on SAP's products and services that may interest you. If you prefer not to receive promotional e-mail from SAP in the future, please click on the <a href="https://www.sap.com/usa/profile/unsubscribe.epx?PID=10386&amp;PFID=12894" target="_blank">Unsubscribe</a> link.<br ><br >To ensure you continue to receive SAP-related information properly, please add sap@mailsap.com to your address book or safe senders list. This e-mail may contain trade secrets or privileged, undisclosed, or otherwise confidential information. If you have received this e-mail in error, you are hereby notified that any review, copying or distribution of it is strictly prohibited. Please inform us immediately and destroy the original transmittal. Thank you for your cooperation.</p></td>
	</tr></table></center>

<!-- /Footer -->

<!--[if (gte mso 9)|IE]>
      </td>
    </tr>
  </table>
<![endif]-->

</div>
</center>

<style type="text/css">
/** Client-specific Styles */
#outlook a {
	padding:0;
} /* Force Outlook to provide a "view in browser" button. */


@media screen and (max-device-width: 595px), screen and (max-width: 595px) {
                table[class='BodyContent'] {
                    width: 100% !important;
                    padding-right: 0px !important;
                }
                table[class='SideModule'] {
                    width: 100% !important;
                }
                table[class='SideModuleTableLeft'] {
                    width: 45% !important;
                }
                table[class='SideModuleTableRight'] {
                    width: 50% !important;
                }
                img[class='responsiveImage'] {
                    width: 100% !important;
                    max-width: 100% !important;
                    height: auto;
                }

			}

</style></body>
</html>
EOF
    );


    public function __construct() {
    }

    private function _generate_article($feed_id, $c=1, $index=0) {
        $out = '';
        if (isset($this->_feeds[$feed_id]) && count($this->_feeds[$feed_id])) {
            for($i=0;$i<$c;$i++) {
                $content = $this->_feeds[$feed_id][$i+$index]['Publishthis_Content'];
                $out .= Template::replace_vars(
                  self::$templates['article'],
                  array('IMAGE' => $content['image_url'], 'TITLE' => $content['title'], 'URL' => $content['url'], 'SUMMARY' => html::truncate($content['summary'], 260))
                );
            }
        }
        return $out;
    }

    private function _generate_blog($c=1, $index=0) {
        $out = '';
        if (count($this->_feeds[0])) {

            for($i=0;$i<$c;$i++) {
                $content = $this->_feeds[0][$i+$index]['Publishthis_Content'];
                $out .= Template::replace_vars(
                  self::$templates['blog'],
                  array('URL' => $content['url'], 'TITLE' => $content['title'], 'SUMMARY' => html::truncate($content['summary'], 170))
                );
            }
        }
        return $out;
    }

    private function _generate_body() {
        $replace = array(
          'MON_D_YYYY'=>$date = date("F j, Y", time())
        );

        // Headline, intro paragraph, and the email button text/link pulls from category: 1372 (the email button text is the "publisher" field)
        if (isset($this->_feeds[1372]) && count($this->_feeds[1372])) {
            $replace['HEADLINE'] = $this->_feeds[1372][0]['Publishthis_Content']['title'];
            $replace['INTRO_P'] = $this->_feeds[1372][0]['Publishthis_Content']['summary'];
            $replace['BUTTON_LINK'] = $this->_feeds[1372][0]['Publishthis_Content']['url'];
            $replace['BUTTON_TEXT'] = $this->_feeds[1372][0]['Publishthis_Content']['publisher'];
        }

        // The Map image pulls from category: 1373
        if (isset($this->_feeds[1373]) && count($this->_feeds[1373])) {
            $replace['SIDEBAR_IMAGE'] = '<img class="responsiveImage" src="'.$this->_feeds[1373][0]['Publishthis_Content']['image_url'].'" alt="SAP" width="175" height="155" style="height: auto; line-height: 100%; outline: none; text-decoration: none; border: 0px none;" >';
            $replace['SIDEBAR_IMAGE_LINK'] = $this->_feeds[1373][0]['Publishthis_Content']['url'];
        }

        // The Sidebar Copy pulls from category: 1374
        if (isset($this->_feeds[1374]) && count($this->_feeds[1374])) {
            $replace['SIDEBAR_HEADING'] = $this->_feeds[1374][0]['Publishthis_Content']['title'];
            $replace['SIDEBAR_P']= $this->_feeds[1374][0]['Publishthis_Content']['summary'];
            $replace['SIDEBAR_BTN_LINK'] = $this->_feeds[1374][0]['Publishthis_Content']['url'];
            $replace['SIDEBAR_BTN_TEXT'] = $this->_feeds[1374][0]['Publishthis_Content']['publisher'];
        }

        // The top Spotlight article from category: 1006
        $replace['SPOTLIGHT_ARTICLE'] = $this->_generate_article(1006);

        // followed by the top two articles from category: 1003
        $replace['ARTICLE_1'] = $this->_generate_article(1003, 1);
        $replace['ARTICLE_2'] = $this->_generate_article(1003, 1, 1);

        // The articles at the bottom should pull from the Business Innovation blog sidebar on the site.
        $replace['BLOGS'] = $this->_generate_blog(3, 0);

        return Template::replace_vars(self::$templates['body'], $replace);
    }

    public function generate($industryObj, $industryFeeds) {
        $this->_industry = $industryObj;
        $this->_feeds = $industryFeeds;

        echo $this->_generate_body();
    }

    public function postSearch($obj=array()) {
        if (isset($obj['data']['Industry_Newsletters'])) {
            if (isset($obj['data']['Industry_Newsletters']['industry_id']) && !empty($obj['data']['Industry_Newsletters']['industry_id'])) {
                $this->where('industry_id', $obj['data']['Industry_Newsletters']['industry_id']);
            }
        }
        return $this->search();
    }
}