<?php
 
class Publishthis_Content extends Model {
    protected $hasMany = array('Tags'=>'Publishthis_Content_Industry');
    public $PublishThis_Feed;
    public $debug = false;
    public $special_sort = false;
    public $industryLimit = 12;
    static $ARCHIVE_CONTENT_DAYS = 90; // archive publishthis_content for X days

    public function getIdFromDocId($docId, $feed_id=false) {
        $this->where('doc_id', $docId);
        if ($feed_id!=false) $this->where('publishthis_feed_id', $feed_id);
        $result = $this->search();
        if (count($result)) return $result[0]['Publishthis_Content']['id'];
        return false;
    }

    public function getIndustryFeedsContent($industry_id) {
        $out = array();
        $feed = new Publishthis_Feed();
        $feeds = $feed->getFeedsByIndustry($industry_id);
        for($i=0;$i<count($feeds);$i++) {
            $contentObj = new Publishthis_Content();
            $contentObj->where('publishthis_feed_id', $feeds[$i]['Publishthis_Feed']['id']);
            //$contentObj->setPage(1);
            $contentObj->setLimit($this->industryLimit);
            $contentObj->orderBy('id', 'ASC');
            if ($feeds[$i]['Publishthis_Feed']['feed_type']=="A") $contentObj->setLimit(4);
            $content = $contentObj->search();
            for($z=0;$z<count($content);$z++) {
                $content[$z]['Publishthis_Content']['shareId'] = $this->_create_shareId($content[$z]);
            }
            $section = ($feeds[$i]['Publishthis_Feed']['section_id']!=0?$feeds[$i]['Publishthis_Feed']['section_id']:($feeds[$i]['Publishthis_Feed']['feed_type']=="T"?"T":0));
            $out[$section] = $content;
        }
        return $out;
    }

    public function import_publishthis_feed() {
      $html2text = new html2textnolinks();

      if ($this->PublishThis_Feed['Publishthis_Feed']['feed_type']=='C') {
        $pt_feed = new PublishThisCuratedFeed();
        $pt_feed->setSection($this->PublishThis_Feed['Publishthis_Feed']['section_id']);
      }
      else if ($this->PublishThis_Feed['Publishthis_Feed']['feed_type']=='T') {
        $pt_feed = new PublishThisTwitterFeed();
      }
      else {
        $pt_feed = new PublishThisFeed();
      }
      $pt_feed->setFeedId($this->PublishThis_Feed['Publishthis_Feed']['feed_id']);
      $ret = $pt_feed->pull();

      if ($this->debug) {
        print "PublishThis_Feed:<br>".print_r($this->PublishThis_Feed,true)."<br>";
        print "Results: ".preg_replace(array('/\n/', '/\s/'), array('<br>', '&nbsp;'), print_r($ret,true))."<br><br><hr><br><br>";
      }

      if ($ret->resp->status!='ERROR') {
        // Find and delete old data
        $ec = new Publishthis_Content();
        $ec->where('publishthis_feed_id', $this->PublishThis_Feed['Publishthis_Feed']['id']);
        //$ec->where('DATEDIFF( NOW( ) , IF( curated_date_updated !=  "", curated_date_updated, IF( curated_date !=  "", curated_date, publish_date ) ) )', Publishthis_Content::$ARCHIVE_CONTENT_DAYS, '>', true);
        $ecr = $ec->search();

        for($d=0;$d<count($ecr);$d++) {
          $ptci = new PublishThis_Content_Industry();
          $ptci->where("publishthis_content_id", $ecr[$d]['Publishthis_Content']['id']);
          foreach ($ptci->search() as $row) {
              $ptcid = new PublishThis_Content_Industry();
              $ptcid->id = $row['Publishthis_Content_Industry']['id'];
              $ptcid->delete();
          }
          $ecd = new Publishthis_Content();
          $ecd->id = $ecr[$d]['Publishthis_Content']['id'];
          $ecd->delete();
        }

        $ptci = new Publishthis_Content_Industry();
        for($z=0;$z<count($ret->resp->data->resultList);$z++) {
          $existing_id = $this->getIdFromDocId($ret->resp->data->resultList[$z]->docId, $this->PublishThis_Feed['Publishthis_Feed']['id']);
          if ($existing_id!=false) $this->id = $existing_id;

          $this->publishthis_feed_id = $this->PublishThis_Feed['Publishthis_Feed']['id'];
          $this->annotation = '';
          if (isset($ret->resp->data->resultList[$z]->annotations)) $this->annotation = html2textnolinks::strip_html($ret->resp->data->resultList[$z]->annotations[0]->annotation);
          if (isset($ret->resp->data->resultList[$z]->contentType)) $this->content_type = $ret->resp->data->resultList[$z]->contentType;
          if (isset($ret->resp->data->resultList[$z]->docId)) $this->doc_id = $ret->resp->data->resultList[$z]->docId;
          if (isset($ret->resp->data->resultList[$z]->publishDate)) $this->publish_date = $ret->resp->data->resultList[$z]->publishDate;
          if (isset($ret->resp->data->resultList[$z]->curatedDate)) $this->curated_date = $ret->resp->data->resultList[$z]->curatedDate;
          if (isset($ret->resp->data->resultList[$z]->curateUpdateDate)) $this->curated_date_updated = $ret->resp->data->resultList[$z]->curateUpdateDate;
          if (isset($ret->resp->data->resultList[$z]->publisher)) $this->publisher = $ret->resp->data->resultList[$z]->publisher;

          $thumb_url = $image_url = "";
          if (isset($ret->resp->data->resultList[$z]->imageUrl))
            $image_url = str_replace('_thumbnail', '_original', $ret->resp->data->resultList[$z]->imageUrl);


          if (isset($ret->resp->data->resultList[$z]->imageUrlThumbnail))
            $thumb_url = $ret->resp->data->resultList[$z]->imageUrlThumbnail;

          $this->image_url = $image_url;
          $this->image_url_thumbnail = $thumb_url;
          if (isset($ret->resp->data->resultList[$z]->photoCredit)) $this->photo_credit = $ret->resp->data->resultList[$z]->photoCredit;
          if (isset($ret->resp->data->resultList[$z]->photoCaption)) $this->photo_caption = $html2text->strip_html($ret->resp->data->resultList[$z]->photoCaption);
          if (isset($ret->resp->data->resultList[$z]->title)) $this->title = $html2text->strip_html($ret->resp->data->resultList[$z]->title);
          if (isset($ret->resp->data->resultList[$z]->summary)) $this->summary = $html2text->strip_html($ret->resp->data->resultList[$z]->summary);
          if (isset($ret->resp->data->resultList[$z]->url)) $this->url = $ret->resp->data->resultList[$z]->url;
          if (isset($ret->resp->data->resultList[$z]->embed)) $this->embed = $ret->resp->data->resultList[$z]->embed;
          if (isset($ret->resp->data->resultList[$z]->statusId)) $this->status_id = $ret->resp->data->resultList[$z]->statusId;
          if (isset($ret->resp->data->resultList[$z]->statusText)) $this->status_text = $ret->resp->data->resultList[$z]->statusText;
          if (isset($ret->resp->data->resultList[$z]->statusUrl)) $this->status_url = $ret->resp->data->resultList[$z]->statusUrl;
          if (isset($ret->resp->data->resultList[$z]->userDisplayName)) $this->user_display_name = $ret->resp->data->resultList[$z]->userDisplayName;
          if (isset($ret->resp->data->resultList[$z]->userScreenName)) $this->user_screen_name = $ret->resp->data->resultList[$z]->userScreenName;
          if (isset($ret->resp->data->resultList[$z]->kloutScore)) $this->klout_score = $ret->resp->data->resultList[$z]->kloutScore;
          if (isset($ret->resp->data->resultList[$z]->followerCount)) $this->follower_count = $ret->resp->data->resultList[$z]->followerCount;

          $contentId = $this->save();

          $industries = array();
          if (isset($ret->resp->data->resultList[$z]->contentCategories)) $industries = $ret->resp->data->resultList[$z]->contentCategories;
          $ptci->set_industries($contentId, $industries);
        }

      } else {
        print 'PublishThis Feed error ' . $ret->resp->code . ': ' . $ret->resp->errorMessage . "\n";
      }

    }

    public function getFeedContent() {
        $industry = new Industry();

        $this->showHasMany();

        if (!$this->special_sort) $this->orderBy(array('publish_date', 'curated_date', 'curated_date_updated'), 'DESC');
        else if ($this->special_sort)$this->orderBy(array('curated_date_updated', 'curated_date', 'publish_date'), 'DESC');

        $this->where('publishthis_feed_id', $this->publishthis_feed_id);
        $results = $this->search();

        for($i=0;$i<count($results);$i++) {
            $results[$i]['share_id'] = $this->_create_shareId($results[$i]);
            if (count($results[$i]['Tags'])) {
                for($z=0;$z<count($results[$i]['Tags']);$z++) {
                    $results[$i]['Tags'][$z]['IndustryUrl'] = $industry->get_url($results[$i]['Tags'][$z]['Tags']['industry_id']);
                    $industry->id = $results[$i]['Tags'][$z]['Tags']['industry_id'];
                    $results[$i]['Tags'][$z]['Industry'] = $industry->search();
                }
            }
        }
        return $results;
    }

    private function _create_shareId($data=array()) {
        return urlencode($data['Publishthis_Content']['url']);
    }

    public function findByShareId($shareId=null) {
        return $this->find_by_field("url", urldecode($shareId));
    }
}
