<?php
 
class Publishthis_Feed extends Model {   
    var $subpage_section_ids = array(
        'articles' => 1003, 'video' => 1004, 'resources' => 1005, 'events' => 1006, 'infographic' => 1249,
        'podcasts' => 1250, 'background'=>1314, 'newsletter_headline' => 1372, 'newsletter_image' => 1373,
        'newsletter_sidebar' => 1374,
    );

    var $homepage_section_ids = array(
        'articles' => 1003, 'video' => 1004, 'resources' => 1005, 'events' => 1006
    );

    private function _update_industry_feed($industry_id, $feed_id, $section_id, $type) {
        $i = new PublishThis_Feed();
        $e = $i->get_feed_by_industry_section($industry_id, $feed_id, $section_id, $type);
        if (count($e)) $i->id = $e[0]['Publishthis_Feed']['id'];
        $i->industry_id = $industry_id;
        $i->feed_id = $feed_id;
        $i->feed_type = $type;
        $i->section_id = $section_id;
        $i->save();
    }

    protected function _remove_industry_feed($industry_id, $feed_id, $section_id, $type) {
        $i = new PublishThis_Feed();
        $e = $i->get_feed_by_industry_section($industry_id, $feed_id, $section_id, $type);
        if (count($e)) {
            $i->id = $e[0]['Publishthis_Feed']['id'];
            $i->delete();
        }
    }

    function update_industry_feeds($industry_id, $feed_id) {
        $iObj = new Industry();
        $iObj->id = $industry_id;
        $industry = $iObj->search();

        $this->_update_industry_feed($industry_id, $feed_id, '0', 'A');

        if ($industry['Industry']['twitter_enable']=="1") {
            $this->_update_industry_feed($industry_id, $feed_id, '0', 'T');
        } else $this->_remove_industry_feed($industry_id, $feed_id, '0', 'T');

        foreach(array_keys($this->subpage_section_ids) as $section)
            $this->_update_industry_feed($industry_id, $feed_id, $thgis->subpage_section_ids[$section], 'C');
    }
    
    function get_feed_by_industry_section($industry_id, $feed_id, $section_id, $type) {
        $this->where('industry_id', $industry_id);
        $this->where('feed_id', $feed_id);
        $this->where('section_id', $section_id);
        $this->where('feed_type', $type);
        return $this->search();
    }
    
    function getFeedsByIndustry($industry_id) {
        $feeds = $this->find_by_field('industry_id', $industry_id);
        return $feeds;
    }

}