<!DOCTYPE html>
<html class="no-js">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <title><?php echo $title?></title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <!-- Place favicon.ico and apple-touch-icon(s) in the root directory -->        
        
        <?php echo $html->includeCss('normalize', true)?>
        <?php echo $html->includeCss('main', true)?>
        <?php echo $html->includeCss('colorbox', true)?>
        <?php echo $html->includeCss('style', true)?>
        <?php echo $html->includeCss('admin-style', true)?>        
        <?php echo $html->includeJs('vendor/modernizr-2.7.0.min', true)?>
    </head>
    <body>
        <!--[if lt IE 8]>
            <p class="browsehappy">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> to improve your experience.</p>
        <![endif]-->
        <div class="admin_wrapper">
            <table border="0" cellspacing="0" cellpadding="0" style="border-collapse:collapse;">
                <tr>
                    <td class="admin_left" valign="top">
                        <div class="admin_left_inner">
                            <div class="admin_logo"><?php echo $html->image(array('src'=>'logo.png', 'admin'=>true, 'alt'=>'SAP'))?></div>
                            <div class="admin_conversations_title">
                                Conversations on
                            </div>
                            <div class="admin_conversations_text">
                                The Future
                                of Business
                            </div>
                            <?php if ($html->loggedIn()) { ?>
                                <div class="side_orangebar"></div>
                                <div class="side_row">
                                    Conversations Home Page<br>
                                    <div class="side_row_links">
                                        <?php echo $html->link_obj(array('text'=>'Preview', 'path'=>'homes/index/1', 'target'=>'_blank'))?>&nbsp;|&nbsp;<?php echo $html->link('Settings', 'homes/view/1')?>
                                    </div>
                                </div>
                                <div class="side_orangebar"></div>
                                <?php for($i=0;$i<count($industries);$i++) { ?>
                                    <div class="side_row">
                                        <?php echo $industries[$i]['Industry']['title']?><br>
                                        <div class="side_row_links left">
                                            <?php
                                            echo $html->link_obj(array('text'=>'Preview', 'path'=>'industries/index/'.$industries[$i]['Industry']['id'], 'target'=>'_blank'));
                                            echo '&nbsp;|&nbsp;';
                                            echo $html->link('Settings', 'industries/view/'.$industries[$i]['Industry']['id']);
                                            echo '&nbsp;|&nbsp;';
                                            echo $html->link_obj(array('text'=>'Newsletter', 'path'=>'industries/newsletter/'.$industries[$i]['Industry']['id'], 'target'=>'_blank'));
                                            //echo '&nbsp;|&nbsp;';
                                            //echo $html->link('Newsletters', 'industry_newsletters/search/?Industry_Newsletter[industry_id]='.$industries[$i]['Industry']['id']);
                                            ?>
                                        </div>
                                        <div class="side_row_links right">
                                            <?php
                                            if ($i>0) {
                                                echo $html->link($html->image(array('src'=>'transparent.gif', 'class'=>'moveup', 'admin'=>true, 'alt'=>'Move Up')), 'industries/moveup/'.$industries[$i]['Industry']['id']).'&nbsp;';
                                            }
                                            if ($i<count($industries)-1) {
                                                echo $html->link($html->image(array('src'=>'transparent.gif', 'class'=>'movedown', 'admin'=>true, 'alt'=>'Move Down')), 'industries/movedown/'.$industries[$i]['Industry']['id']);
                                            }
                                            ?>
                                        </div>
                                        <div class="clearfix"></div>
                                    </div>
                                <?php } ?>
                                <div class="side_new_page">
                                    <?php echo $html->link($html->image(array('src'=>'transparent.gif', 'class'=>'plus', 'admin'=>true)).' New Page', 'industries/view'); ?>
                                </div>
                                <div class="side_defaulticons">
                                    <?php echo $html->link('Article Icon Override', 'defaulticons/viewall'); ?>
                                </div>
                            <?php } ?>
                        </div>
                    </td>
                    <td class="admin_right" valign="top">
                        <div class="admin_topbar"></div>
                        <div class="admin_header">
                            <?php if ($html->loggedIn()) { ?>
                                Welcome, <?php echo $_SESSION['User']['username']?>
                                <div class="admin_nav">
                                    <!--<?php echo $html->link('Account Settings', ''); ?>
                        &nbsp;|&nbsp;-->
                                    <?php echo $html->link('Logout', 'users/logout'); ?>
                                </div>
                            <?php } ?>
                        </div>
                        <div class="clearfix"></div>

                        <div class="admin_content">
                            <?php if (isset($debug) && $debug!="") { ?>
                                <div class="debug">
                                    <?php echo $debug?>
                                </div>
                            <?php } ?>

                            <?php if (isset($message) && $message!="") { ?>
                                <div class="error">
                                    <?php echo $message?>
                                </div>
                            <?php } ?>
