/*
This is the HTML5 Video routines JS file for the Universal Media Player
/global/ui/richmedia/projects/rm_UMP/rm_UMP_html.js
Version: 03.15.11 - VS
*/

/*
Rich Media JavaScript: 
Rich Media HTML5 Video routines for the UMP
Perhaps these should be seperated out from here, I don't know...

Created:	01.05.11 - VS
Last Edit: 
01.10.11 - added HTML5 scripts - DH
01.11.11 - added Require.js js - VS
01.18.11 - removed controls HTML
02.01.11 - rebuilt for new backbone - VS
02.16.11 - display progress load bar - DAH
02.16.11 - removed irritating console message - DAH
02.21.11 - added if statement to interval loop to prevent undefined data array
02.22.11 - tweaked seekto/scrub bar stuff...
02.23.11 - Moved movie play/pause event handlers into startVideo() - dah
02.23.11 - mute and unmute - dah
02.28.11 - finished volume controls - dah
02.28.11 - no volume controls on ipad - dah
02.28.11 - check for existence of buffered when showing scrubber - dah
03.01.11 - added unload function to make video shut up when leaving page - dah
03.03.11 - Call UMP.videoEnded() when video signals 'ended' event - dah
03.07.11 - Load progress bar shrinks left to right - dah
03.08.11 - FF has no buffered for autoseek, fix to work anyway - dah
03.08.11 - fixed load progress for all browsers. - vs
03.10.11 - added unbind html events function. - vs
03.15.11 - minor tweaks. - vs

Description:

*/


var UMPhtml = {
	
	htVidID: '',
	htVidObj: null,
	
	
	init: function(vidID) {
		//Leave this blank or commented out if not needed...	
		
		//Get Required Scripts and CSS
		/*require(["/global/js/rm_platform/projects/UMP/old/rm_browser.js", "/global/js/rm_platform/projects/UMP/old/Apple/AC_QuickTime.js", "/global/js/rm_platform/projects/UMP/old/rm_jsplayer/rm_jsplayer.js", "/global/js/rm_platform/rm_getcss.js"], function() {	
			//JS finished loading. Load CSS
			//rmGetCSS.load_CSS("/demos/rm_testing/rm_player/rm_jsplayer/rm_jsplayer.css");
			
			//All Done, perform stuff...
		});*/
		
		
		//Bind Events:
		$("#ump_controller").bind("play_event.html5", function(e, vidID, myValue){
			//Play Video: vidID
			//myValue is a text 'play' - not really required, but...
			
			//play function here
			UMPhtml.htVidObj.play();
		});
		
		$("#ump_controller").bind("pause_event.html5", function(e, vidID, myValue){
			//Pause Video: vidID
			//myValue is a text 'pause' - not really required, but...
			
			//pause function here
			UMPhtml.htVidObj.pause();
		});
		
		$("#ump_controller").bind("mute_event.html5", function(e, vidID, myValue){
			//mute function here
			UMP.embedDataArray[vidID]['isMuted'] = true;
			UMPhtml.htVidObj.muted = true;
		});
		
		$("#ump_controller").bind("unmute_event.html5", function(e, vidID, myValue){
			//mute function here
			UMP.embedDataArray[vidID]['isMuted'] = false;
			UMPhtml.htVidObj.muted = false;
		});
		
		$("#ump_controller").bind("volume_event.html5", function(e, vidID, myValue){
			UMPhtml.htVidObj.volume = myValue;
		});
		
		$("#ump_controller").bind("interval_event.html5", function(e, vidID, myValue){
			//This is the global interval event.
			if (UMP.embedDataArray[vidID] && UMPhtml.htVidObj !== null) {
				//Set these every second
				UMP.embedDataArray[vidID]['totaltime'] = UMPhtml.htVidObj.duration;
				UMP.embedDataArray[vidID]['currenttime'] = UMPhtml.htVidObj.currentTime;
			}
		});
		
		if (rmBrowser.Name !== 'Firefox' && rmBrowser.Name !== 'IE') {
			//IE and FF don't need this event.
			$("#ump_controller").bind("interval_event.loadProgress.html5", function(e, vidID, myValue){
				if (UMP.embedDataArray[vidID] && UMPhtml.htVidObj !== null) {
					//display load progress bar
					var w = 0;
					var tt = UMPhtml.htVidObj.duration;
					//UMP.UMPconsole.log('UMPhtml.htVidObj.buffered: ' + UMPhtml.htVidObj.buffered);
					if(UMPhtml.htVidObj.buffered !== undefined)
					{
						try {
							//UMP.UMPconsole.log('Load Progress: ' + UMPhtml.htVidObj.buffered);
							w = $("#progressbg").width() - ($("#progressbg").width() * (UMPhtml.htVidObj.buffered.end(0) / tt));
						}
						catch(ee) {
							//UMP.UMPconsole.log('get progress error');
						}
					}
					//UMP.UMPconsole.log('load progress width: ' + w);
					$("#progressload").width(w);
					//$('#progressload').css({'left': ($('#progressbg').width() - w) + "px"});
					//UMP.UMPconsole.log('fullscreen: ' + UMPhtml.htVidObj.webkitEnterFullscreen);
				}
			});
		}
		
		$("#ump_controller").bind("seek_event.html5", function(e, vidID, seekTime){
			var t1 = UMP.stringToTime(seekTime);
			UMPhtml.htVidObj.currentTime = t1;
		});		
		
		$("#ump_controller").bind("fullscreen_event.html5", function(e, vidID, myValue){
			//alert(UMPhtml.htVidObj.webkitEnterFullscreen);
			UMPhtml.htVidObj.webkitEnterFullscreen();
		});		
	},
	
	getUMPId: function() {
	
		return "UMP_" + this.htVidID + "_html5_video";
	}, 

	makeOpenVideoTag: function(vidID) {
	
		this.htVidID = vidID;
		var openHTML = "";
		openHTML += '<video style="border-style:none" id="' + this.getUMPId();
		openHTML += '" width="' + UMP.embedDataArray[vidID]['width'];
		openHTML += '" height="' + UMP.embedDataArray[vidID]['height'];
		openHTML += '">';
		if (UMP.embedDataArray[vidID]['source-ogv']) {
			openHTML += '<source src="' + UMP.embedDataArray[vidID]['source-ogv'] + '" type="video/ogg"/>';
		}
		openHTML += '<source src="' + UMP.embedDataArray[vidID]['source-mp4'] + '" type="video/mp4"/>';
		return(openHTML);
		
	},
	
	
	makeCloseVideoTag: function(vidID) {
		
		closeHTML = "";
		closeHTML += "</video>";
		return(closeHTML);
	}, 
	
	doautoseek: function ()
	{
		try
		{
			//UMP.UMPconsole.log('progress 2 - ' + UMPhtml.htVidObj.buffered.end(0));
			if(UMPhtml.htVidObj.buffered != undefined)
			{
				if(UMPhtml.htVidObj.buffered.end(0) >= UMPhtml.autoSeek)
				{
					UMPhtml.htVidObj.currentTime = UMPhtml.autoSeek;
					UMPhtml.htVidObj.play();
				}
			}
			//'hard' seek for FF ver < 4.
			//if the video is not ready, will fall into 'catch'
			else
			{
				UMP.UMPconsole.log('FF seeking...');
				UMPhtml.htVidObj.currentTime = UMPhtml.autoSeek;
				UMPhtml.htVidObj.play();
			}
			$('#' + UMPhtml.getUMPId()).unbind('canplay');
			$('#' + UMPhtml.getUMPId()).unbind('canplaythrough');
			//$('#' + UMPhtml.getUMPId()).unbind('progress');
		}
		catch(ee)
		{
			//UMP.UMPconsole.log('get progress error');
		}
	}, 
	
	startVideo: function(seeks) {
		var pElement = document.getElementById(this.getUMPId());
		if(pElement != null)
		{
			UMPhtml.htVidObj = pElement;
			pElement.load();
			pElement.addEventListener('progress',UMPhtml.progressHandler,false);
			if(seeks == undefined)
			{
				pElement.play();
			}
			else
			{
				UMPhtml.autoSeek = UMP.stringToTime(seeks);
				$('#' + UMPhtml.getUMPId()).bind('canplay', UMPhtml.doautoseek);
				$('#' + UMPhtml.getUMPId()).bind('canplaythrough', UMPhtml.doautoseek);
				//$('#' + UMPhtml.getUMPId()).bind('progress', UMPhtml.doautoseek);
			}
			
			//now bind movie events
			$(window).unload( 
				function () 
				{
					//alert(UMPhtml.htVidObj.src);
					UMPhtml.htVidObj.src = "";
					UMPhtml.htVidObj.load();
				}
			);

			
			$('#' + UMPhtml.getUMPId()).bind('play',
				function ()
				{
					UMP.playVideo(UMPhtml.htVidID);
				}
			);

			$('#' + UMPhtml.getUMPId()).bind('pause',
				function ()
				{
					UMP.pauseVideo(UMPhtml.htVidID);
				}
			);

			$('#' + UMPhtml.getUMPId()).bind('volumechange',
				function ()
				{
					if(UMPhtml.htVidObj.muted && !UMP.embedDataArray[vidID]['isMuted'])
					{
						UMP.mute(UMPhtml.htVidID);
					}
					else if(!UMPhtml.htVidObj.muted && UMP.embedDataArray[vidID]['isMuted'])
					{
						UMP.unmute(UMPhtml.htVidID);
					}
				}
			);

			$('#' + UMPhtml.getUMPId()).bind('ended',
				function ()
				{
					UMP.videoEnded(UMPhtml.htVidID);
				}
			);
		
			//-------Manually doing this in the controls js------- vs 02.22.11 
			//show/hide fullscreen button

			//UMP.UMPconsole.log('fullscreen: ' + UMPhtml.htVidObj.webkitEnterFullscreen);
			//var tmpf = ((UMPhtml.htVidObj.webkitEnterFullscreen != undefined) && (UMPhtml.htVidObj.webkitEnterFullscreen != null));
			//UMPcontrols.showFullscreen(tmpf);
		}
	},
	
	progressHandler: function(e){
	  if(e.total && e.loaded){
		  //this only seems to work in FF.
		  //UMP.UMPconsole.log('e.loaded: ' + e.loaded);
		  var thePercent = e.loaded / e.total;
		 // UMP.UMPconsole.log('FireFox Loaded Percent: ' + thePercent); // Never hits 100% - need a finished Loadeding event.
		 // UMP.UMPconsole.log('e.loaded: ' + e.loaded + ' | e.total: ' + e.total);
		 
		 if(thePercent > .9) {
			thePercent = 1; 
		 }
		 newProgWidth = $("#progressbg").width() - ($("#progressbg").width() * thePercent);
		$("#progressload").width(newProgWidth);
		 
	  } else {
		   // do nothing because we're autobuffering.
	  }
	},
	
	doneLoading: function(e) {
			UMP.UMPconsole.log('done loading');
	},
	
	removeHTMLbinds: function(vidID) {
		$("#ump_controller").unbind("play_event.html5");
		$("#ump_controller").unbind("pause_event.html5");
		$("#ump_controller").unbind("mute_event.html5");
		$("#ump_controller").unbind("unmute_event.html5");
		$("#ump_controller").unbind("volume_event.html5");
		$("#ump_controller").unbind("interval_event.html5");	
		$("#ump_controller").unbind("interval_event.loadProgress.html5");
		$("#ump_controller").unbind("seek_event.html5");
		$("#ump_controller").unbind("fullscreen_event.html5");
	}
	
}
