/*
Check Head for Linked Files Utility
/global/js/rm_platform/utils/rm_checkHead.js
RLC 20101213
*/

define(['utils/rm_indexOf', 'utils/rm_console'],
	function(indexOf, rm_console) {
		return rmCheckHead();
	}
);

function rmCheckHead() {
	this.head_links;
	this.head_scripts;
	
	var can_serialize = $.support.htmlSerialze;
	
	var m_console = new rmConsole('rmCheckHead');
	
	function init() {
		if (typeof(head_links) === 'undefined') {
			head_links = [];
			head_scripts = [];
			$('head').children().each(function(index, value) {
				if (value.nodeName == "SCRIPT") {
					head_scripts.push(value.src);
				} else if (value.nodeName == "LINK") {
					head_links.push(value.href);
				}
			});
		}
	}
	
	this.find = function(url) {
		if (head_links.indexOf(url) > -1) {
			return true;
		}
		if (head_scripts.indexOf(url) > -1) {
			return true;
		}
		return false;
	}
	
	this.add = function(data) {
		var url = '';
		var head_array;
		
		$(data).each(function (index, element) {
			//first get the type (need to use src or href)
			if (element.nodeName == "SCRIPT") {
				url = $(element).attr('src');
				head_array = head_scripts;
			} else if (element.nodeName == "LINK") {
				url = $(element).attr('href');
				head_array = head_links;
			}
			//if the url isn't already loaded, move to <head> and push to array
			if (!find(url)) {
				head_array.push(url);
				$('head').append(element);
			}
		});
	}
	
	init();
	return this;
}