<?php

class HTML {
	private $js = array();
        public $campaigncode = false;
        public $campaignsource = false;
        protected $_inject = array();

        public function setInject($type, $v) {
            if (!isset($this->_inject[$type])) $this->_inject[$type] = array();
            array_push($this->_inject[$type], $v);
        }
        public function inject($type) {
            if (isset($this->_inject[$type])) {
                if ($type=='js') return '<script language="JavaScript">'.implode('', $this->_inject[$type]).'</script>';
            }
            return false;
        }
        public static function truncate($in, $length, $suffix="...") {
            $out = $in;
            if (strlen($in)>$length) {
                $out = substr($in,0,$length);
                if (preg_match('/^(\S+)/', substr($in,$length), $matches)) {
                    $out .= $matches[1];
                }
                $out .= $suffix;
            }
            return $out;
        }
        
	function shortenUrls($data) {
		$data = preg_replace_callback('@(https?://([-\w\.]+)+(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@', array(get_class($this), '_fetchTinyUrl'), $data);
		return $data;
	}
        
	private function _fetchTinyUrl($url) { 
		$ch = curl_init(); 
		$timeout = 5; 
		curl_setopt($ch,CURLOPT_URL,'http://tinyurl.com/api-create.php?url='.$url[0]); 
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1); 
		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout); 
		$data = curl_exec($ch); 
		curl_close($ch); 
		return '<a href="'.$data.'" target = "_blank" >'.$data.'</a>'; 
	}

	function sanitize($data) {
		return mysql_real_escape_string($data);
	}

    protected function _tagLinkWithCampaignCode($obj) {
        $path = $obj['path'];
        $startsHash = (isset($path)&&strlen($path)>0&&substr($path, 0, 1)=='#'?true:false);
        if (!$startsHash && isset($obj['remote']) && $obj['remote']==true && $this->campaigncode!=false) {
            if (strpos($path, '?')!==false) $path .= '&amp;';
            else $path .= '?';
            $path .= 'campaigncode='.$this->campaigncode;
        }

        return $path;
    }

    protected function _tagLinkWithCampaignSource($obj) {
        $path = $obj['path'];
        $startsHash = (isset($path)&&strlen($path)>0&&substr($path, 0, 1)=='#'?true:false);
        if (!$startsHash && isset($obj['remote']) && $obj['remote']==true && $this->campaignsource!=false) {
            if (strpos($path, '?')!==false) $path .= '&amp;';
            else $path .= '?';
            $path .= 'source='.$this->campaignsource;
        }

        return $path;
    }

    function link_obj($obj=array()) {
        $text = '';
        if (isset($obj['text'])) $text = $obj['text'];

        $startsHash = (isset($path)&&strlen($path)>0&&substr($path, 0, 1)=='#'?true:false);
        $obj['path'] = $this->_tagLinkWithCampaignCode($obj);
        $obj['path'] = $this->_tagLinkWithCampaignSource($obj);

        $a = '<a ';
        $a .= (isset($obj['path'])?' href="'.(!$startsHash?(!isset($obj['remote'])||$obj['remote']==false?SITE_URL.'/':''):'').$obj['path'].'"':'');
        $a .= (isset($obj['class'])?' class="'.$obj['class'].'"':'');
        $a .= (isset($obj['target'])?' target="'.$obj['target'].'"':'');
        $a .= (isset($obj['id'])?' id="'.$obj['id'].'"':'');
        $a .= (isset($obj['onclick'])?' onclick="'.$obj['onclick'].'"':'');
        $a .= (isset($obj['style'])?' style="'.$obj['style'].'"':'');
        if (isset($obj['data'])) {
            foreach (array_keys($obj['data']) as $k) {
                $a .= ' data-'.$k.'="'.$obj['data'][$k].'"';
            }
        }
        if (isset($obj['ga'])) {
            $va = 'Default';
            $vb = 'Default';
            $vc = $obj['path'];
            if (isset($obj['ga']['a'])) $va = $obj['ga']['a'];
            if (isset($obj['ga']['b'])) $vb = $obj['ga']['b'];
            if (isset($obj['ga']['c'])) $vc = $obj['ga']['c'];
            $a .= ' data-track-event="1" data-ga-a="'.$va.'" data-ga-b="'.$vb.'" data-ga-c="'.$vc.'"';
        }

        $a .= '>'.$text.'</a>';
        return $a;
    }
        
	public static function link($text,$path,$class = null, $prompt = null,$confirmMessage = "Are you sure?") {
		$path = str_replace(' ','-',$path);
		if ($prompt) {
			$data = '<a '.($class!==null?'class="'.$class.'" ':'').'href="javascript:void(0);" onclick="javascript:redirectConfirm(\''.SITE_URL.'/'.$path.'\',\''.$confirmMessage.'\')">'.$text.'</a>';
		} else {
			$data = '<a '.($class!==null?'class="'.$class.'" ':'').'href="'.SITE_URL.'/'.$path.'">'.$text.'</a>';	
		}
		return $data;
	}

        public static function image($obj=array()) {
            $prefix = '';
            if (isset($obj['src']) && strpos($obj['src'], '://')===false) $prefix .= SITE_URL.(isset($obj['admin'])&&$obj['admin']==true?'/admin/img/':'/images/');

            if (isset($obj['phpThumb'])) {
                $opt = 'src='.$obj['src'];
                foreach (array_keys($obj['phpThumb']) as $k) $opt .= '&'.$k.'='.$obj['phpThumb'][$k];
                $obj['src'] = '/'.phpThumbURL($opt, '/phpThumb/phpThumb.php');
                $prefix = '';
            }

            $img = '<img ';
            $img .= (isset($obj['src'])?' src="'.$prefix.$obj['src'].'"':'');
            $img .= (isset($obj['alt'])?' alt="'.$obj['alt'].'"':'');
            $img .= (isset($obj['class'])?' class="'.$obj['class'].'"':'');
            $img .= (isset($obj['style'])?' style="'.$obj['style'].'"':'');
            $img .= (isset($obj['align'])?' align="'.$obj['align'].'"':'');
            if (isset($obj['data'])) {
                foreach (array_keys($obj['data']) as $k) {
                    $img .= ' data-'.$k.'="'.$obj['data'][$k].'"';
                }
            }
            $img .= '>';
            return $img;
        }
        
	public static function includeJs($fileName, $admin=false) {
		$data = '<script type="text/javascript" src="'.SITE_URL.($admin?'/admin':'').'/js/'.$fileName.'.js"></script>';
		return $data;
	}

	public static function includeCss($fileName, $admin=false) {
		$data = '<link rel="stylesheet" type="text/css" href="'.SITE_URL.($admin?'/admin':'').'/css/'.$fileName.'.css">';
		return $data;
	}
        
        public static function selectOptions($options, $selected="") {
            $data = '';
            foreach (array_keys($options) as $key) {
                $sel = false;
                if ( (is_array($selected) && in_array($key, $selected)) || (!is_array($selected) && $key==$selected)) $sel = true;
                $data .= '<option value="'.htmlentities($key).'"'.($sel?' selected=selected':'').'>'.htmlentities($options[$key]).'</option>';
            }
            return $data;
        }
        
        public static function selectOptionsFromModel($options, $model, $keyField, $labelField, $selected=false) {
            $data = '';
            for($i=0;$i<count($options);$i++) {
                $sel = false;
                if (!isset($options[$i][$model]) || !isset($options[$i][$model][$keyField]) || !isset($options[$i][$model][$labelField])) continue;

                $key = $options[$i][$model][$keyField];
                $label = $options[$i][$model][$labelField];                
                if ( (is_array($selected) && in_array($key, $selected)) || (!is_array($selected) && $key==$selected)) $sel = true;
                $data .= '<option value="'.htmlentities($key).'"'.($sel?' selected=selected':'').'>'.htmlentities($label).'</option>';
            }
            return $data;            
        }
        
        function formData($data, $model, $key) {
            if (!isset($data[$model])) return false;
            if (!isset($data[$model][$key])) return false;
            return htmlentities($data[$model][$key]);
        }
        
        function loggedIn() {
            if (isset($_SESSION['User']) && isset($_SESSION['User']['id'])) return true;
            return false;
        }
}