<?php

/*
 * Copyright (C) Adam Stanley - All Rights Reserved
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 * Written by Adam Stanley <adamstanley@gmail.com>, October 2013
 */

/**
 * Description of htmlhome
 *
 * @author Adam
 */
class HTMLHomeBlocks extends HTML {
    //put your code here
    function renderBlocks($type, $data, $opt=array()) {
        $out = '';
        for($i=0;$i<count($data);$i++) {            
            $out .= $this->renderBlock(array_merge(array('type'=>$type,'options'=>$opt), $data[$i]['Publishthis_Content']));
        }
        return $out;
    }
    
    function renderBlock($data=array()) {
        $out = '';
        
        if ($data['type'] == 'image_link') {
            // slideshare open-book document picture video
            $out .= '<div class="col-md-4">
            <div class="block-wrapper hp-content-block">
              <div class="content-block front" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Article" data-ga-c="'.$data['url'].'">
                '.$this->image(array('src'=>$data['image'], 'class'=>'content-img', 'alt'=>'')).'
                <div class="content-description-wrapper '.$data['icon'].'">'.$data['title'].'</div>
              </div>
              <div class="hover-back">
                <div class="article-meta-wrapper">
                  <div class="favicon_wrapper">'.$data['favicon'].'</div>
                  <span class="article-website">'.$data['publisher'].'</span>
                  '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'<h4 class="article-title">'.$data['title'].'</h4>', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                  <p>'.html::truncate($data['summary'], 180).'</p>
                  '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'Read the article ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                </div>
              </div>              
            </div>
          </div>';
            
        } else if ($data['type'] == 'wide_image_link') {
            $out .= '<div class="col-md-8">
            <div class="block-wrapper hp-content-block wide-hover">
              <div class="content-block front" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Article" data-ga-c="'.$data['url'].'">
                <div class="wide_block_outer"><div class="wide_block_inner">'.$this->image(array('src'=>$data['image'], 'class'=>'target-size content-img', 'alt'=>'')).'</div></div>
                <div class="content-description-wrapper '.$data['icon'].'">'.$data['title'].'</div>
                <div class="hover-back">
                  <div class="article-meta-wrapper">
                    <div class="favicon_wrapper">'.$data['favicon'].'</div>
                    <span class="article-website">'.$data['publisher'].'</span>
                    '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'<h4 class="article-title">'.$data['title'].'</h4>', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                    <p>'.html::truncate($data['summary'], 180).'</p>
                    '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'Read the article ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                  </div>
                </div>
              </div>
            </div>
          </div>';
                        
        } else if ($data['type']=='newsletter') {
            $out .= '<div class="col-md-4 hidden-xs">
              <div class="content-block hp-content-block newsletter-container">
                <iframe class="newsletter-iframe" height="296" src="'.IFRAME_URL_NEWSLETTER_HP_BLOCK.'" frameborder="0" marginwidth="0" marginheight="0" scrolling="no" border="0"></iframe>
              </div>
            </div>';


        } else if ($data['type']=='video') {
            $out .= '<div class="col-md-4 videoBlock">
              <div class="content-block hp-content-block front" data-ignore-ios="1" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Video" data-ga-c="'.$data['url'].'">
                '.
                $this->link_obj(array('path'=>$data['url'], 'remote'=>true, 'data'=>array('videoid'=>$data['video_id']), 'class'=>"content-block-play-btn", 'ga'=>array('a'=>'Home', 'b'=>'Video'))).
                $this->image(array('src'=>$data['image'], 'class'=>'source-size', 'alt'=>'')).
                '<div class="content-description-wrapper video">'.$data['caption'].'</div>
              </div>
            </div>';

        } else if ($data['type'] == 'wide_video') {
            // slideshare open-book document picture video
            $out .= '<div class="col-md-8 videoBlock">
              <div class="content-block front hp-content-block" data-ignore-ios="1" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Video" data-ga-c="'.$data['url'].'">
                '.$this->link_obj(array('path'=>$data['url'], 'remote'=>true, 'data'=>array('videoid'=>$data['video_id']), 'class'=>'content-block-play-btn', 'ga'=>array('a'=>'Home', 'b'=>'Video'))).'
                <div class="wide_block_outer"><div class="wide_block_inner">'.$this->image(array('src'=>$data['image'], 'class'=>'source-size', 'alt'=>'')).'</div></div>
                <div class="content-description-wrapper video">'.$data['caption'].'</div>
              </div>
            </div>';
                              
        } else if ($data['type']=='twitter') {
            $tweet = $data['tweet'];
            $tweet = preg_replace("#(^|[\n ])@([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/\\2\">@\\2</a>'", $tweet);
            $tweet = preg_replace("#(^|[\n ])\#([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/search?q=%23\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/search?q=%23\\2\">#\\2</a>'", $tweet);
            $tweet = preg_replace("#(^|[\n ])([\w]+?://[\w]+[^ \"\n\r\t<]*)#ise", "'\\1<a target=\"_blank\" href=\"\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"\\2\">\\2</a>'", $tweet);
            $tweet = preg_replace("#(^|[\n ])((www|ftp)\.[^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://\\2\">\\2</a>'", $tweet);
            
            $out .= '<div class="col-md-4 hidden-xs">
              <div class="content-block hp-content-block">
                <div class="twitter-block-wrapper">
                  <div class="twitter-block-content">
                    <p class="lt-grey"><span class="white twitter-name">'.$data['name'].'</span>  '.$this->link_obj(array('path'=>'https://twitter.com/'.$data['username'], 'text'=>'@'.$data['username'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Twitter'))).' <span class="time">'.$data['time'].'</span></p>
                    <p class="lt-grey">'.$tweet.'</p>
                  </div>
                  '.
                  $this->image(array('src'=>$data['image'], 'alt'=>'')).'
                  <div class="content-description-wrapper twitter-icon" style="color:#cccccc;">Join the conversation <br>'.$this->link_obj(array('path'=>'https://twitter.com/search?q=%23futureofbiz%20%23sap', 'remote'=>true, 'target'=>'_blank', 'text'=>'#futureofbiz #SAP', 'ga'=>array('a'=>'Home', 'b'=>'Twitter'))).'</div>
                </div>
              </div>
            </div>';
            
        } else if ($data['type']=="secondary_background_image") {
            $data = $data['data'];
            //print_r($data);exit;
            $out = '<div id="wrapper_overlay" style="background-image: url(\''.$data[0]['Publishthis_Content']['image_url'].'\');">'.$this->image(array('class'=>'visible-ie8 ie8background', 'src'=>$data[0]['Publishthis_Content']['image_url'], 'alt'=>'')).$this->image(array('src'=>'secondary-bg-overlay.png', 'alt'=>'')).'</div>';

        } else if ($data['type']=="secondary_header") {
            if (count($data['data'])) {
                $industry = $data['industry'];
                $data = $data['data'];

                $out .= '<div class="col-md-8">
                  <div class="secondary-header-wrapper">
                  <div class="content-block secondary-header-block">
                    '.$this->image(array("class"=>"featured-img hidden-xs", "src"=>$data['Publishthis_Content']['image_url'], "alt"=>"")).
                    $this->image(array("class"=>"featured-img visible-xs", "src"=>$data['Publishthis_Content']['image_url'], "alt"=>"")).'
                    <div class="featured pov-title active content-description-wrapper">      
                      <span class="featured-meta regular">'.date("F d, Y", strtotime($data['Publishthis_Content']['publish_date'])).'</span>
                      <h2 class="featured-title white">'.$this->link_obj(array('text'=>$data['Publishthis_Content']['title'], 'remote'=>true, 'path'=>$data['Publishthis_Content']['url'], 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Spotlight Article'))).'</h2>                  
                        <a class="our-pov-btn our-pov-wrapper'.(trim($data['Publishthis_Content']['annotation'])==""?' hide':'').'" href="#">
                          <span class="helper"></span>
                          '.$this->image(array('class'=>"our-pov-img", 'src'=>'icons/our-pov.png', 'alt'=>'')).'
                        </a>                  
                    </div>
                    <div class="featured pov-info content-description-wrapper">      
                      <span class="featured-meta regular">'.$data['Publishthis_Content']['annotation'].'</span>
                        <a class="our-pov-btn second our-pov-wrapper" href="#">
                          <span class="helper"></span>
                          '.$this->image(array("class"=>"our-pov-img second", "src"=>"icons/our-pov.png", "alt"=>"")).'
                        </a>
                        <a class="our-pov-btn circle" href="#">'.$this->image(array("class"=>"circle-close", "src"=>"icons/circle-close.png", "alt"=>"")).'</a>
                    </div>
                  </div>
                  </div>
                </div>';
            }

        } else if ($data['type']=="secondary_infographic") {
            $industry = $data['industry'];
            $data = $data['data'];
            if (count($data)>0) {
                for($i=0;$i<1;$i++) {
                    $out .= '<div class="col-md-4">
                      <div class="content-block">
                        '.$this->image(array("src"=>$data[0]['Publishthis_Content']['image_url'], 'alt'=>'')).'
                        '.$this->link_obj(array('path'=>$data[0]['Publishthis_Content']['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Infographic'), 'text'=>'<div class="view-infographic-btn content-description-wrapper"><span class="view-infographic-text">View Infographic </span>'.$this->image(array("src"=>"buttons/view-infographic-btn.png", "alt"=>"")).'</div>')).'
                      </div>
                    </div>';
                }
            }
            
        } else if ($data['type']=="secondary_carousel") {
            $industry = $data['industry'];
            $data = $data['data'];
            
            $out .= '<!-- Essentials Carousel -->
            <div class="col-md-4">
              <div class="content-block">
                 '.$this->image(array('src'=>'essentials-background.png', 'class'=>'essentials-bg', 'alt'=>'')).'
                  <div class="custom-centricity-btn content-description-wrapper" >'.$this->image(array('class'=>'light-bulb-icon', 'src'=>'icons/light-bulb-icon.png', 'alt'=>'', "style"=>"float:left")).'<span class="custom-centricity-text"> '.$industry.' Essentials</span></div>
                <div id="essentials-carousel" class="carousel slide" data-ride="carousel">
                  <!-- Indicators -->
                  <ol class="carousel-indicators">';
            for($i=0;$i<count($data);$i++) {
                $out .= '<li data-target="#essentials-carousel" data-slide-to="'.$i.'"'.($i==0?' class="active"':'').'></li>';
            }
            $out .= '
                  </ol>

                  <!-- Wrapper for slides -->
                  <div class="carousel-inner">';
            for($i=0;$i<count($data);$i++) {
                $out .= '
                    <div class="item '.($i==0?'active':'').'">
                      <div class="essentials-bg-wrapper">'.$this->image(array('src'=>$data[$i]['Publishthis_Content']['image_url'], 'alt'=>'')).'</div>
                      <div class="carousel-caption">
                        <span class="carousel-small">'.$data[$i]['Publishthis_Content']['photo_credit'].'</span><br>
                        '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Essentials Box'), 'text'=>'<span class="carousel-link">'.$data[$i]['Publishthis_Content']['title'].' ›</span>')).'
                      </div>
                    </div>';
            }
            $out .= '
                  </div>

                  <!-- Controls -->
                  <a class="left carousel-control" href="#essentials-carousel" data-slide="prev">
                    <span class="icon-prev"></span>
                  </a>
                  <a class="right carousel-control" href="#essentials-carousel" data-slide="next">
                    <span class="icon-next"></span>
                  </a>
                </div>
              </div>
            </div>';            
            
        } else if ($data['type']=="secondary_article") {
            $industry = $data['options']['industry'];
            $favicon = favicon::getFaviconUrl($data['url']);
            $out .= '<div class="col-md-half secondary-article-wrapper">
          <div class="secondary-article-inner">
          <div class="article-meta-wrapper">
            <div class="favicon_wrapper">'.($favicon!==false?'<img class="favicon" src="'.$favicon.'" alt="">':'').'</div>
            <span class="article-website">'.$data['publisher'].'</span>
            <span class="article-date">'.date("F d, Y", strtotime($data['publish_date'])).'</span>
          </div>
          '.$this->image(array('src'=>$data['image_url'], 'class'=>'visible-device article-thumbnail', 'alt'=>'')).'
          '.$this->link_obj(array('path'=>$data['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Third Party Article'), 'text'=>'<h4 class="article-title">'.$data['title'].'</h4>')).'
          '.$this->image(array('src'=>$data['image_url'], 'class'=>'hidden-device article-thumbnail', 'alt'=>'')).'
          <p>
            '.html::truncate($data['summary'], 260).'
          </p>
          '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Third Party Article'), 'text'=>'Read the article ›')).'
        </div>
        </div>';

        } else if ($data['type']=="secondary_videos") {
            $industry = $data['industry'];
            $data = $data['data'];
            
            $out .= '<!-- Media Carousel -->
            <div class="media-carousel-wrapper visible-device">
                <div id="media-carousel" class="carousel slide" data-ride="carousel">
                  <!-- Indicators -->
                  <ol class="carousel-indicators">';
            for($i=0;$i<count($data);$i++) {
                $out .= '<li data-target="#media-carousel" data-slide-to="'.$i.'" class=""></li>';                    
            }
            $out .= '
                  </ol>

                  <!-- Wrapper for slides -->
                  <div class="carousel-inner">';
            for($i=0;$i<count($data);$i++) {
                $out .= '                        
                    <div class="item '.($i==0?'active':'').'">
                     <div class="main-video-wrapper">
                        <div class="video-sm-embed" data-ytembed="1" data-videoid="'.$data[$i]['Publishthis_Content']['video_id'].'" data-track-event="1" data-ga-a="'.$industry.'" data-ga-b="Videos" data-ga-c="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'">
                            <div class="video-container hidden-xs">
                                <iframe id="carousel_player'.$i.'" width="320" height="180" src="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'?autoplay=0&rel=0&enablejsapi=1&html5=1&version=3&controls=0&showinfo=0&origin='.urlencode(SITE_URL).'" frameborder="0" allowfullscreen></iframe>
                            </div>
                            <div class="visible-xs">
                                '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'class'=>'content-block-play-btn', 'target'=>'_blank', 'remote'=>true, 'text'=>'', 'ga'=>array('a'=>$industry, 'b'=>'Videos'))).
                                $this->image(array('src'=>$data[$i]['Publishthis_Content']['image_url'])).'
                            </div>
                        </div>
                        <div class="video-meta">
                          <span class="article-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
                          <h4 class="article-title regular">'.html::truncate($data[$i]['Publishthis_Content']['title'], 45).'</h4>
                          <p>'.html::truncate($data[$i]['Publishthis_Content']['summary'], 190).'</p>
                        </div>
                        <div class="clearfix"></div>
                      </div>
                    </div>';
            }
            $out .= '
                  </div>

                  <!-- Controls -->
                  <a class="left carousel-control" href="#media-carousel" data-slide="prev">
                    <span class="icon-prev"></span>
                  </a>
                  <a class="right carousel-control" href="#media-carousel" data-slide="next">
                    <span class="icon-next"></span>
                  </a>
              </div>
            </div>';
            for($i=0;$i<1;$i++) {
                $out .= '            
            <div class="main-video-wrapper hidden-device">
            <div class="video-lrg-wrapper">
              <div id="video-lrg-embed" data-ytembed="1" data-videoid="'.$data[$i]['Publishthis_Content']['video_id'].'" data-track-event="1" data-ga-a="'.$industry.'" data-ga-b="Videos" data-ga-c="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'">
                  <div class="video-container">
                    <iframe id="spplayer" width="320" height="180" src="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'?autoplay=0&rel=0&enablejsapi=1&html5=1&version=3&controls=0&showinfo=0&origin='.urlencode(SITE_URL).'" frameborder="0" allowfullscreen></iframe>
                  </div>
              </div>
              <div class="video-meta">
                <span class="article-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
                <h4 class="article-title regular">'.html::truncate($data[$i]['Publishthis_Content']['title'], 45).'</h4>
                <p class="article-summary">'.html::truncate($data[$i]['Publishthis_Content']['summary'], 190).'</p>
              </div>
              <div class="clearfix"></div>
            </div>
          </div>';
            }
            $out .= '<div class="small-videos hidden-device">';
            for($i=0;$i<count($data);$i++) {
                //print 'video: '.print_r($data[$i],true).'<br><br>';
                $out .= '
            <div class="single-video-wrapper">              
              <div class="video-thumb-wrapper">
                <div class="video-overlay '.($i==0?'active':'').'" ></div>
                '.$this->link_obj(array(
                    'data'=>array(
                        'date'=>base64_encode(date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date']))),
                        'videoid'=>base64_encode($data[$i]['Publishthis_Content']['video_id']),
                        'title'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['title'], 45)),
                        'summary'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['summary'], 190)),
                        ),
                    'path'=>$data[$i]['Publishthis_Content']['url'],
                    'text'=>$this->image(array('class'=>'small-video-image', 'src'=>$data[$i]['Publishthis_Content']['image_url'], 'alt'=>'')),
                    'ga'=>array('a'=>$industry, 'b'=>'Videos')
                )).'
                </div>
              '.$this->link_obj(array(
                'data'=>array(
                    'date'=>base64_encode(date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date']))),
                    'videoid'=>base64_encode($data[$i]['Publishthis_Content']['video_id']),
                    'title'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['title'], 45)),
                    'summary'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['summary'], 190)),
                    ),
                'class'=>'small-video-info'.($i==0?' active':''),
                'path'=>$data[$i]['Publishthis_Content']['url'],
                'text'=>'<p>'.$data[$i]['Publishthis_Content']['title'].'</p>',
                'ga'=>array('a'=>$industry, 'b'=>'Videos')
              )).'
            </div>';

            }
          $out .= '</div>';          
          
        } else if ($data['type']=="secondary_blogposts") {
            $industry = $data['industry'];
            $data = $data['data'];
            $out .= '<div class="col-md-half-device rp-30"><hr>';
            
            for($i=0;$i<ceil(count($data)/2);$i++) {
                $out .= '
          <div class="secondary-sidebar-content-wrapper">
            <span class="standard">By </span><span class="blog-author">'.$data[$i]['Publishthis_Content']['publisher'].' </span><span class="standard">on </span><span class="blog-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'target'=>'_blank', 'remote'=>true, 'class'=>'white', 'ga'=>array('a'=>$industry, 'b'=>'Business Innovation Blog'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>
          </div>';
            }
            
            $out .= '</div>
          <div class="col-md-half-device lp-30">
            <hr class="visible-sm tsFill">';
            for($i;$i<count($data);$i++) {
              $out .= '
          <div class="secondary-sidebar-content-wrapper">
            <span class="standard">By </span><span class="blog-author">'.$data[$i]['Publishthis_Content']['publisher'].' </span><span class="standard">on </span><span class="blog-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'target'=>'_blank', 'remote'=>true, 'class'=>'white', 'ga'=>array('a'=>$industry, 'b'=>'Business Innovation Blog'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>
          </div>';
            }
            $out .= '</div>';
            
        } else if ($data['type']=="secondary_podcasts") {
            $industry = $data['industry'];
            $data = $data['data'];
            $out .= '<div class="col-md-half-device rp-30"><hr>';
            
            for($i=0;$i<ceil(count($data)/2);$i++) {
                $out .= '<div class="secondary-sidebar-content-wrapper" id="jp-interface-jquery_jplayer_'.$i.'">
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'class'=>'white', 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Podcast'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>

            <div id="jquery_jplayer_'.$i.'" class="jp-jplayer" data-mp3="'.base64_encode($data[$i]['Publishthis_Content']['url']).'"></div>
            <div id="jp_container_'.$i.'" class="jp-audio skin2">
              <div class="jp-type-single">
                <div class="jp-gui jp-interface">
                  <ul class="jp-controls">
                    <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-play', 'tabindex'=>1, 'ga'=>array('a'=>$industry, 'b'=>'Podcast', 'c'=>$data[$i]['Publishthis_Content']['url']), 'text'=>$this->image(array('src'=>'jp-play.png', 'alt'=>'')))).'</li>
                    <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-pause', 'tabindex'=>1, 'text'=>$this->image(array('src'=>'jp-pause.png', 'alt'=>'')))).'</li>
                  </ul>
                  <div class="jp-progress">
                    <div class="jp-seek-bar">
                      <div class="jp-play-bar"></div>
                    </div>
                  </div>
                  <div class="jp-time-holder">
                    <span class="jp-current-time"></span><span> / </span><span class="jp-duration"></span>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="jp-no-solution">
                  <span>Update Required</span>
                  To play the media you will need to either update your browser to a recent version or update your <a href="http://get.adobe.com/flashplayer/" target="_blank">Flash plugin</a>.
                </div>
              </div>
            </div>

            <!--'.$this->image(array('src'=>'icons/podcast-media-player.png', 'alt'=>'')).'-->
          </div>';
            }
            $out .= '        </div>
        <div class="col-md-half-device lp-30"><hr class="visible-sm">';
            for($i;$i<count($data);$i++) {
                $out .= '<div class="secondary-sidebar-content-wrapper" id="jp-interface-jquery_jplayer_'.$i.'">
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'class'=>'white', 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Podcast'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>
                
            <div id="jquery_jplayer_'.$i.'" class="jp-jplayer" data-mp3="'.base64_encode($data[$i]['Publishthis_Content']['url']).'"></div>
            <div id="jp_container_'.$i.'" class="jp-audio skin2">
              <div class="jp-type-single">
                <div class="jp-gui jp-interface" id="jp-interface-jquery_jplayer_'.$i.'">
                  <ul class="jp-controls">
                    <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-play', 'tabindex'=>1, 'ga'=>array('a'=>$industry, 'b'=>'Podcast', 'c'=>$data[$i]['Publishthis_Content']['url']), 'text'=>$this->image(array('src'=>'jp-play.png', 'alt'=>'')))).'</li>
                    <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-pause', 'tabindex'=>1, 'text'=>$this->image(array('src'=>'jp-pause.png', 'alt'=>'')))).'</li>
                  </ul>
                  <div class="jp-progress">
                    <div class="jp-seek-bar">
                      <div class="jp-play-bar"></div>
                    </div>
                  </div>
                  <div class="jp-time-holder">
                    <span class="jp-current-time"></span><span> / </span><span class="jp-duration"></span>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="jp-no-solution">
                  <span>Update Required</span>
                  To play the media you will need to either update your browser to a recent version or update your <a href="http://get.adobe.com/flashplayer/" target="_blank">Flash plugin</a>.
                </div>
              </div>
            </div>


            <!--'.$this->image(array('src'=>'icons/podcast-media-player.png', 'alt'=>'')).'-->
          </div>';
            }
            $out .= '</div>';
        
        } else if ($data['type']=="video_modal") {
            $out = '<!-- VIDEO MODAL -->
    <div class="modal" id="video-1">
      <div class="modal-dialog">
        <a href="#" data-dismiss="modal" class="modal-close-tab">'.$this->image(array('src'=>'icons/close-tab.png', 'alt'=>'')).'</a>
          <div class="modal-content">
              <!--
            <div class="modal-header">
              <h4 class="modal-title bold">Video Title</h4>
            </div>
              -->
            <div class="modal-body"><div class="video-container" id="video-1-embed"></div></div>
            <div class="modal-footer">
              <a href="#" data-dismiss="modal" class="btn">Close</a>
            </div>
          </div>
        </div>
    </div>';
        } else if ($data['type']=="newsletter_modal") {
            $out = '<!-- SIGN UP MODAL -->
    <div class="modal" id="sign-up-modal">
      <div class="modal-dialog">
        <a href="#" data-dismiss="modal" class="modal-close-tab">'.$this->image(array('src'=>'icons/close-tab.png', 'alt'=>'')).'</a>
          <div class="modal-content newsletter-container">
            <iframe class="newsletter-iframe" src="'.IFRAME_URL_NEWSLETTER_POPUP.(isset($data['leadformix_id'])?'?m='.$data['leadformix_id']:'').'" frameborder="0" marginwidth="0" marginheight="0" scrolling="no" border="0"></iframe>
            <div class="modal-footer">
              <a href="#" data-dismiss="modal" class="btn">Close</a>
            </div>
          </div>
        </div>
    </div>';
        }
        
        return $out;
    }
}
