<?php

/*
 * Copyright (C) Adam Stanley - All Rights Reserved
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 * Written by Adam Stanley <adamstanley@gmail.com>, October 2013
 */

/**
 * Description of htmlhome
 *
 * @author Adam
 */
class HTMLHomeBlocks extends HTML {
    //put your code here
    function renderBlocks($type, $data, $opt=array()) {
        $out = '';
        for($i=0;$i<count($data);$i++) {            
            $out .= $this->renderBlock(array_merge(array('type'=>$type,'options'=>$opt), $data[$i]['Publishthis_Content']));
        }
        return $out;
    }
    
    function renderBlock($data=array()) {
        if ($data['type']=="map") {
            $out = '<div class="col-md-12 big-calendar active">
              <div class="visible-xs calendar">
                <div class="content-description-wrapper">'.(count($data['events'])?'
                  <span class="gold mobile-event-title">Upcoming Events:</span><br>
                  <span class="mobile-event-location">'.$data['events'][0]['Event']['city'].'</span><br>
                  <span class="mobile-event-date">'.(strtotime($data['events'][0]['Event']['date'])!==false?date("F j, Y", strtotime($data['events'][0]['Event']['date'])):$data['events'][0]['Event']['date']).'  |  '.$data['events'][0]['Event']['location'].'</span>
                  '.$this->image(array('src'=>'icons/calendar.png', 'class'=>'calendar-icon')):'').'
                </div>
              </div>
              <div class="pin-wrapper hidden-xs">';

            for($i=0;$i<count($data['events']);$i++) {
                $out .= '
                <a data-city="1" data-location="'.base64_encode($data['events'][$i]['Event']['city']).'" data-date="'.base64_encode((strtotime($data['events'][$i]['Event']['date'])!==false?date("F j, Y", strtotime($data['events'][$i]['Event']['date'])):$data['events'][$i]['Event']['date'])).'" data-venue="'.base64_encode($data['events'][$i]['Event']['location']).'" data-speaker="'.base64_encode($data['events'][$i]['Event']['speaker_detail']).'" data-topics="'.base64_encode($data['events'][$i]['Event']['topics']).'" data-learnurl="'.base64_encode($data['events'][$i]['Event']['learn_more_link']).'" data-regbtn="'.base64_encode($data['events'][$i]['Event']['register_button']).'" data-learnbtn="'.base64_encode($data['events'][$i]['Event']['learn_more_button']).'" data-regurl="'.base64_encode($data['events'][$i]['Event']['register_link']).'" href="#">
                    <div data-x="'.$data['events'][$i]['Event']['x_pos'].'" data-y="'.$data['events'][$i]['Event']['y_pos'].'" class="city-'.$i.' city-pin '.($i==0?'active':'').'" src="'.SITE_URL.'/images/icons/map-pin.png" alt=""></div>
                </a>';
            }
            $out .= '
              </div>'.
              $this->image(array('src'=>'mobile-map-bg.jpg', 'class'=>'visible-xs', 'alt'=>'')).
              $this->image(array('src'=>'map-bg.png', 'class'=>'hidden-xs', 'alt'=>'')).'
              <div class="city-info-wrapper">
                '.$this->image(array('src'=>'upcoming-events-tab.png', 'alt'=>'')).'
                <div class="city-info-content">
                  <h3 class="city-name gold">'.(count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['city']:'').'</h3>
                  <div id="city-time">'.(count($data['events'][0])&&isset($data['events'][0]['Event'])?(strtotime($data['events'][0]['Event']['date'])!==false?date("F j, Y", strtotime($data['events'][0]['Event']['date'])):$data['events'][0]['Event']['date']):'').'</div><div id="city-venue">'.(count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['location']:'').'</div>
                  <div class="city-speaker'.(count($data['events'][0])&&isset($data['events'][0]['Event'])&&trim($data['events'][0]['Event']['speaker_detail'])==""?' hidden':'').'">Featured Speaker: <span id="city-speaker">'.(count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['speaker_detail']:'').'</span></div>
                  <div id="city-buttons">
                    '.
              $this->link_obj(array(
                'text' => '<span id="city-learnmore-cta">'.(count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['learn_more_button']:'').'</span>',
                'id'=>'city-learnmore-btn',
                'class'=>'btn-pad-bottom btn-cta'.(count($data['events'][0])&&isset($data['events'][0]['Event'])&&(trim($data['events'][0]['Event']['learn_more_link'])==""&&trim($data['events'][0]['Event']['learn_more_button'])=="")?' hidden':''),
                'remote' => true,
                'target' => '_blank',
                'path' => (count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['learn_more_link']:''),
                'ga'=>array('a'=>'Home','b'=>'Secondary Navigation')
              )).
              $this->link_obj(array(
                'text' => '<span id="city-register-cta">'.(count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['register_button']:'').'</span>',
                'id'=>'city-register-btn',
                'class'=>'btn-pad-bottom btn-cta'.(count($data['events'][0])&&isset($data['events'][0]['Event'])&&(trim($data['events'][0]['Event']['register_link'])==""&&trim($data['events'][0]['Event']['register_button'])=="")?' hidden':''),
                'remote' => true,
                'target' => '_blank',
                'path' => (count($data['events'][0])&&isset($data['events'][0]['Event'])?$data['events'][0]['Event']['register_link']:''),
                'ga'=>array('a'=>'Home','b'=>'Secondary Navigation')
              )).'
                    <div class="clearfix"></div>
                  </div>
                  <p class="city-topics regular"><span style="color:#333;font-weight:600;">Topics:</span><br>
                      <span id="city-topics">'.$data['events'][0]['Event']['topics'].'</span>
                  </p>
                </div>
              </div>
            </div>
            <!-- MOBILE EVENTS -->
            <div class="mobile-events-trigger visible-xs">
                <div class="mobile-event-drop-down">
                    <div class="mobile-event-header">
                        <p class="regular black">View All Upcoming Events</p>
                        '.$this->image(array('class'=>'nav-down-arrow active', 'src'=>'icons/nav-down-arrow.png', 'alt'=>'')).'
                    </div>
                </div>
                <div class="mobile-event-drop-down-items-wrapper">
                    <ul class="mobile-event-drop-down-items">';

            for($i=0;$i<count($data['events']);$i++) {
                if ($i>0) $out .= '<hr class="mobile-events-rule">';

                $out .= $this->link_obj(array(
                  'path' => $data['events'][$i]['Event']['learn_more_link'],
                  'remote' => true,
                  'text' => '<li>'.$data['events'][$i]['Event']['city'].'<br><span class="mobile-event-drop-meta">'.(strtotime($data['events'][$i]['Event']['date'])!==false?date("F j, Y", strtotime($data['events'][$i]['Event']['date'])):$data['events'][$i]['Event']['date']).'  |  '.$data['events'][$i]['Event']['location'].'</span></li>',
                  'ga'=>array('a'=>'Home','b'=>'Secondary Navigation')
                ));
            }
            $out .= '
                    </ul>
                </div>
            </div>
            <div class="visible-xs" style="margin-top:25px;"></div>';
        } else if ($data['type'] == 'feed') {
            $out = '
            <div class="col-md-12">
                <div class="block-wrapper hp-content-block" style="height:100%">
                    <div class="hidden-xs">
                        '.$this->image(array('src'=>$data['feed'][0]['Publishthis_Content']['image_url'], 'class'=>'content-img', 'alt'=>'')).'
                        <div class="map_feed_right">
                            <div class="map_feed_right_wrapper">
                              <div class="map_feed_right_inner">
                                  <div class="map_feed_title">'.$data['feed'][0]['Publishthis_Content']['title'].'</div>
                                  <div class="map_feed_summary">
                                    <span id="feed_truncate">'.$data['feed'][0]['Publishthis_Content']['summary'].'</span>
                                    <span id="feed_truncated"></span>
                                  </div>
                                  <div class="map_feed_link">
                                    '.$this->link_obj(array(
                                        'class'=>'map-read-more',
                                        'path'=>$data['feed'][0]['Publishthis_Content']['url'],
                                        'remote'=>true,
                                        'target'=>'_blank',
                                        'text'=>'Explore the forums'.$this->image(array('src'=>'icons/right-arrow.png', 'class'=>'map-right-arrow', 'alt'=>''))
                                    )).'
                                  </div>
                              </div>
                            </div>
                        </div>
                        <div style="clear:both"></div>
                    </div>
                    <div class="visible-xs">
                        '.$this->image(array('src'=>$data['feed'][1]['Publishthis_Content']['image_url'], 'class'=>'content-img', 'alt'=>'')).'
                        <div class="map-description-wrapper">
                            <div class="map_feed_title">'.$data['feed'][1]['Publishthis_Content']['title'].'</div>
                              <div class="map_feed_link">
                                '.$this->link_obj(array(
                                  'class'=>'map-read-more',
                                  'path'=>$data['feed'][1]['Publishthis_Content']['url'],
                                  'remote'=>true,
                                  'target'=>'_blank',
                                  'text'=>'Explore the forums'
                                )).'
                              </div>
                        </div>

                    </div>
                </div>
            </div>';

            //$out = '<div class="col-md-12">TODO: Custom Feed HTML</div>';
            /*
             if (isset($data['feed']) && count($data['feed'])) {
                for($i=0;$i<count($data['feed']);$i++) {
                    //print print_r($data['feed'][$i], true)."<br><br>";
                }
                //exit;
            }
            */
        } else if ($data['type'] == 'image_link') {
            // slideshare open-book document picture video
            $out = '<div class="col-md-4">
            <div class="block-wrapper hp-content-block">
              <div class="content-block front" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Article" data-ga-c="'.$data['url'].'">
                '.$this->image(array('src'=>$data['image'], 'class'=>'content-img', 'alt'=>'')).'
                <div class="content-description-wrapper '.$data['icon'].'">'.$data['title'].'</div>
              </div>
              <div class="hover-back">
                <div class="article-meta-wrapper">
                  <div class="favicon_wrapper">'.$data['favicon'].'</div>
                  <span class="article-website">'.$data['publisher'].'</span>
                  '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'<h4 class="article-title">'.$data['title'].'</h4>', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                  <p>'.html::truncate($data['summary'], 170).'</p>
                  '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'Read the article ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                  '.(isset($data['enable_share'])&&$data['enable_share']==true?$this->link_obj(array('class'=>'news-read-more', 'path'=>'?url='.urlencode($data['shareId']), 'text'=>'Share ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Share'))):'').'
                  <ul class="article-tags-ul">';

              for($i=0;$i<count($data['Tags']);$i++)
                $out .= '<li class="article-tags-li"><a href="'.$data['Tags'][$i]['IndustryUrl'].'" target="_blank">'.$data['Tags'][$i]['Industry']['Industry']['title'].'</a></li>';

                  $out .= '</ul>
                </div>
              </div>              
            </div>
          </div>';
            
        } else if ($data['type'] == 'wide_image_link') {
            $out = '<div class="col-md-8">
            <div class="block-wrapper hp-content-block wide-hover">
              <div class="content-block front" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Article" data-ga-c="'.$data['url'].'">
                <div class="wide_block_outer"><div class="wide_block_inner">'.$this->image(array('src'=>$data['image'], 'class'=>'target-size content-img', 'alt'=>'')).'</div></div>
                <div class="content-description-wrapper '.$data['icon'].'">'.$data['title'].'</div>
                <div class="hover-back">
                  <div class="article-meta-wrapper">
                    <div class="favicon_wrapper">'.$data['favicon'].'</div>
                    <span class="article-website">'.$data['publisher'].'</span>
                    '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'<h4 class="article-title">'.$data['title'].'</h4>', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                    <p>'.html::truncate($data['summary'], 180).'</p>
                    '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'text'=>'Read the article ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Article'))).'
                    '.(isset($data['enable_share'])&&$data['enable_share']==true?$this->link_obj(array('class'=>'news-read-more', 'path'=>'?url='.urlencode($data['shareId']), 'text'=>'Share ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Share'))):'').'
                    <ul class="article-tags-ul">';

            for($i=0;$i<count($data['Tags']);$i++)
                $out .= '<li class="article-tags-li"><a href="'.$data['Tags'][$i]['IndustryUrl'].'" target="_blank">'.$data['Tags'][$i]['Industry']['Industry']['title'].'</a></li>';

            $out .= '</ul>
                  </div>
                </div>
              </div>
            </div>
          </div>';
                        
        } else if ($data['type']=='newsletter') {
            $out = '<div class="col-md-4 hidden-xs">
              <div class="content-block hp-content-block newsletter-container">
                <iframe class="newsletter-iframe" height="296" src="'.IFRAME_URL_NEWSLETTER_HP_BLOCK.'" frameborder="0" marginwidth="0" marginheight="0" scrolling="no" border="0"></iframe>
              </div>
            </div>';


        } else if ($data['type']=='video') {
            $out = '<div class="col-md-4 videoBlock">
              <div class="content-block hp-content-block front" data-ignore-ios="1" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Video" data-ga-c="'.$data['url'].'">
                '.
                $this->link_obj(array('path'=>$data['url'], 'remote'=>true, 'data'=>array('videoid'=>$data['video_id']), 'class'=>"content-block-play-btn", 'ga'=>array('a'=>'Home', 'b'=>'Video'))).
                $this->image(array('src'=>$data['image'], 'class'=>'source-size', 'alt'=>'')).
                '<div class="content-description-wrapper video">'.$data['caption'].'</div>
              </div>
            </div>';

        } else if ($data['type'] == 'wide_video') {
            // slideshare open-book document picture video
            $out = '<div class="col-md-8 videoBlock">
              <div class="content-block front hp-content-block" data-ignore-ios="1" data-link="'.$data['url'].'" data-track-event="1" data-ga-a="Home" data-ga-b="Video" data-ga-c="'.$data['url'].'">
                '.$this->link_obj(array('path'=>$data['url'], 'remote'=>true, 'data'=>array('videoid'=>$data['video_id']), 'class'=>'content-block-play-btn', 'ga'=>array('a'=>'Home', 'b'=>'Video'))).'
                <div class="wide_block_outer"><div class="wide_block_inner">'.$this->image(array('src'=>$data['image'], 'class'=>'source-size', 'alt'=>'')).'</div></div>
                <div class="content-description-wrapper video">'.$data['caption'].'</div>
              </div>
            </div>';
                              
        } else if ($data['type']=='twitter') {
            $tweet = $data['tweet'];
            $tweet = preg_replace("#(^|[\n ])@([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/\\2\">@\\2</a>'", $tweet);
            $tweet = preg_replace("#(^|[\n ])\#([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/search?q=%23\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/search?q=%23\\2\">#\\2</a>'", $tweet);
            $tweet = preg_replace("#(^|[\n ])([\w]+?://[\w]+[^ \"\n\r\t<]*)#ise", "'\\1<a target=\"_blank\" href=\"\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"\\2\">\\2</a>'", $tweet);
            $tweet = preg_replace("#(^|[\n ])((www|ftp)\.[^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://\\2\">\\2</a>'", $tweet);
            
            $out = '<div class="col-md-4 hidden-xs">
              <div class="content-block hp-content-block">
                <div class="twitter-block-wrapper">
                  <div class="twitter-block-content">
                    <p class="lt-grey"><span class="white twitter-name">'.$data['name'].'</span>  '.$this->link_obj(array('path'=>'https://twitter.com/'.$data['username'], 'text'=>'@'.$data['username'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Twitter'))).' <span class="time">'.$data['time'].'</span></p>
                    <p class="lt-grey">'.$tweet.'</p>
                  </div>
                  '.
                  $this->image(array('src'=>$data['image'], 'alt'=>'')).'
                  <div class="content-description-wrapper twitter-icon" style="color:#cccccc;">Join the conversation <br>'.$this->link_obj(array('path'=>'https://twitter.com/search?q=%23futureofbiz%20%23sap', 'remote'=>true, 'target'=>'_blank', 'text'=>'#futureofbiz #SAP', 'ga'=>array('a'=>'Home', 'b'=>'Twitter'))).'</div>
                </div>
              </div>
            </div>';
            
        } else if ($data['type']=="secondary_background_image") {
            $data = $data['data'];
            //print_r($data);exit;
            $out = '';
            if (count($data))
              $out = '<div id="wrapper_overlay" style="background-image: url(\''.$data[0]['Publishthis_Content']['image_url'].'\');">'.$this->image(array('class'=>'visible-ie8 ie8background', 'src'=>$data[0]['Publishthis_Content']['image_url'], 'alt'=>'')).$this->image(array('src'=>'secondary-bg-overlay.png', 'alt'=>'')).'</div>';

        } else if ($data['type']=="secondary_header") {
            if (count($data['data'])) {
                $industry = $data['industry'];
                $data = $data['data'];

                if ($data['Publishthis_Content']['content_type']=="video") {
                    $out = '
                    <div class="col-md-8 col-sm-8 col-xs-12 original">
                      <div class="secondary-header-wrapper">
                      <div class="content-block secondary-header-block">
                        <div data-track-event="1" data-ga-a="'.$industry.'" data-ga-b="Featured Video" data-ga-c="http://www.youtube.com/embed/'.$data['Publishthis_Content']['video_id'].'">
                            <div class="video-container hidden-xs">
                                <div id="header_YTPlayer"></div>
                            </div>
                            <div class="visible-xs">
                                '.$this->link_obj(array('path'=>$data['Publishthis_Content']['url'], 'class'=>'content-block-play-btn', 'target'=>'_blank', 'remote'=>true, 'text'=>'', 'ga'=>array('a'=>$industry, 'b'=>'Videos'))).
                        $this->image(array('src'=>$data['Publishthis_Content']['image_url'])).'
                            </div>
                        </div>
                        <div class="featured pov-title active content-description-wrapper">
                          <h2 class="featured-title white">'.$this->link_obj(array('text'=>$data['Publishthis_Content']['title'], 'remote'=>true, 'path'=>$data['Publishthis_Content']['url'], 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Spotlight Article'))).'</h2>
                            <a class="our-pov-btn our-pov-wrapper'.(trim($data['Publishthis_Content']['annotation'])==""?' hide':'').'" href="#">
                              <span class="helper"></span>
                              '.$this->image(array('class'=>"our-pov-img", 'src'=>'icons/our-pov.png', 'alt'=>'')).'
                            </a>
                        </div>
                        <div class="featured pov-info content-description-wrapper">
                          <span class="featured-meta regular">'.$data['Publishthis_Content']['annotation'].'</span>
                            <a class="our-pov-btn second our-pov-wrapper" href="#">
                              <span class="helper"></span>
                              '.$this->image(array("class"=>"our-pov-img second", "src"=>"icons/our-pov.png", "alt"=>"")).'
                            </a>
                            <a class="our-pov-btn circle" href="#">'.$this->image(array("class"=>"circle-close", "src"=>"icons/circle-close.png", "alt"=>"")).'</a>
                        </div>
                      </div>
                      </div>
                    </div>
                    <script>
                    // YT API init is handled in custom.js. These parameters are being passed in.
                    var headerPlayerTracked = 0;
                    var headerPlayer;
                    var headerPlayerOpts = {
                        width: 320,
                        height: 180,
                        videoId: "'.$data['Publishthis_Content']['video_id'].'",
                        playerVars: { "autoplay":0, "rel":0, "html5":1, "version":3, "controls":0, "showinfo":0, "enablejsapi":1, "origin":"'.SITE_URL.'" },
                        events: {
                            onStateChange: function(event) {
                                if (event.data == YT.PlayerState.PLAYING) {
                                    if (!headerPlayerTracked) {
                                        var trackParent = $("#header_YTPlayer").parents(\'[data-track-event="1"]\');
                                        GA.track(trackParent.data("ga-a"), trackParent.data("ga-b"), trackParent.data("ga-c"));
                                        headerPlayerTracked = 1;
                                    }
                                }
                            }
                        }
                    };
                    </script>';

                } else {
                    $out = '<div class="col-md-8 col-sm-8 col-xs-12 original">
                      <div class="secondary-header-wrapper">
                      <div class="content-block secondary-header-block">
                        '.$this->image(array("phpThumb"=>array("w"=>"980", "h"=>"652", "far"=>"C"), "class"=>"featured-img hidden-xs", "src"=>$data['Publishthis_Content']['image_url'], "alt"=>"")).
                        $this->image(array("phpThumb"=>array("w"=>"730", "h"=>"730", "zc"=>"C"), "class"=>"featured-img visible-xs", "src"=>$data['Publishthis_Content']['image_url'], "alt"=>"")).'
                        <div class="featured pov-title active content-description-wrapper">
                          <span class="featured-meta regular">'.date("F d, Y", strtotime($data['Publishthis_Content']['publish_date'])).'</span>
                          <h2 class="featured-title white">'.$this->link_obj(array('text'=>$data['Publishthis_Content']['title'], 'remote'=>true, 'path'=>$data['Publishthis_Content']['url'], 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Spotlight Article'))).'</h2>
                            <a class="our-pov-btn our-pov-wrapper'.(trim($data['Publishthis_Content']['annotation'])==""?' hide':'').'" href="#">
                              <span class="helper"></span>
                              '.$this->image(array('class'=>"our-pov-img", 'src'=>'icons/our-pov.png', 'alt'=>'')).'
                            </a>
                        </div>
                        <div class="featured pov-info content-description-wrapper">
                          <span class="featured-meta regular">'.$data['Publishthis_Content']['annotation'].'</span>
                            <a class="our-pov-btn second our-pov-wrapper" href="#">
                              <span class="helper"></span>
                              '.$this->image(array("class"=>"our-pov-img second", "src"=>"icons/our-pov.png", "alt"=>"")).'
                            </a>
                            <a class="our-pov-btn circle" href="#">'.$this->image(array("class"=>"circle-close", "src"=>"icons/circle-close.png", "alt"=>"")).'</a>
                        </div>
                      </div>
                      </div>
                    </div>';
                }
            }

        } else if ($data['type']=="secondary_infographic") {
            $out = "";
            $industry = $data['industry'];
            $data = $data['data'];
            if (count($data)>0) {
                for($i=0;$i<1;$i++) {
                    $out .= '<div class="col-md-4 col-sm-4 col-xs-12 original">
                      <div class="content-block">
                        '.$this->image(array("src"=>$data[0]['Publishthis_Content']['image_url'], 'alt'=>'')).'
                        '.$this->link_obj(array('path'=>$data[0]['Publishthis_Content']['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Infographic'), 'text'=>'<div class="view-infographic-btn content-description-wrapper"><div style="width:auto;max-width:72.62%;display:inline-block;"><span class="view-infographic-text">'.$data[0]['Publishthis_Content']['title'].'</span></div><div style="margin-left:1.5%;width:22px;display:inline-block;vertical-align:top">'.$this->image(array("src"=>"buttons/view-infographic-btn.png", "alt"=>"", "align"=>"right")).'</div></div>')).'
                      </div>
                    </div>';
                }
            }
            
        } else if ($data['type']=="secondary_carousel") {
            $industry = $data['industry'];
            $data = $data['data'];
            
            $out = '<!-- Essentials Carousel -->
            <div class="col-md-4 col-sm-4 col-xs-12 original">
              <div class="content-block">
                 '.$this->image(array('src'=>'essentials-background.png', 'class'=>'essentials-bg', 'alt'=>'')).'
                  <div class="custom-centricity-btn content-description-wrapper" >'.$this->image(array('class'=>'light-bulb-icon', 'src'=>'icons/light-bulb-icon.png', 'alt'=>'', "style"=>"float:left")).'<span class="custom-centricity-text"> '.$industry.' Essentials</span></div>
                <div id="essentials-carousel" class="carousel slide" data-ride="carousel">
                  <!-- Indicators -->
                  <ol class="carousel-indicators">';
            for($i=0;$i<count($data);$i++) {
                $out .= '<li data-target="#essentials-carousel" data-slide-to="'.$i.'"'.($i==0?' class="active"':'').'></li>';
            }
            $out .= '
                  </ol>

                  <!-- Wrapper for slides -->
                  <div class="carousel-inner">';
            for($i=0;$i<count($data);$i++) {
                $out .= '
                    <div class="item '.($i==0?'active':'').'">
                      <div class="essentials-bg-wrapper">'.$this->image(array('src'=>$data[$i]['Publishthis_Content']['image_url'], 'alt'=>'')).'</div>
                      <div class="carousel-caption">
                        <span class="carousel-small">'.$data[$i]['Publishthis_Content']['publisher'].'</span><br>
                        '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Essentials Box'), 'text'=>'<span class="carousel-link">'.$data[$i]['Publishthis_Content']['title'].' ›</span>')).'
                      </div>
                    </div>';
            }
            $out .= '
                  </div>

                  <!-- Controls -->
                  <a class="left carousel-control" href="#essentials-carousel" data-slide="prev">
                    <span class="icon-prev"></span>
                  </a>
                  <a class="right carousel-control" href="#essentials-carousel" data-slide="next">
                    <span class="icon-next"></span>
                  </a>
                </div>
              </div>
            </div>';            
            
        } else if ($data['type']=="secondary_article") {
            $industry = $data['options']['industry'];
            $favicon = favicon::getFaviconUrl($data['url']);
            $out = '<div class="col-md-half secondary-article-wrapper">
          <div class="secondary-article-inner">
          <div class="article-meta-wrapper">
            <div class="favicon_wrapper">'.($favicon!==false?'<img class="favicon" src="'.$favicon.'" alt="">':'').'</div>
            <span class="article-website">'.$data['publisher'].'</span>
            <span class="article-date">'.date("F d, Y", strtotime($data['publish_date'])).'</span>
          </div>
          '.$this->image(array('src'=>$data['image_url'], 'class'=>'visible-device article-thumbnail', 'alt'=>'')).'
          '.$this->link_obj(array('path'=>$data['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Third Party Article'), 'text'=>'<h4 class="article-title">'.$data['title'].'</h4>')).'
          '.$this->image(array('src'=>$data['image_url'], 'class'=>'hidden-device article-thumbnail', 'alt'=>'')).'
          <p>
            '.html::truncate($data['summary'], 260).'
          </p>
          '.$this->link_obj(array('class'=>'news-read-more', 'path'=>$data['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Third Party Article'), 'text'=>'Read the article ›')).'
        </div>
        </div>';

        } else if ($data['type']=="secondary_article_new") {
            $a = ($data['subtype']=="video"?false:true);
            $favicon = favicon::getFaviconUrl($data['data']['url']);
	        $publisher = preg_match('/.*youtube.*/i', $data['data']['publisher']) ? "YouTube" : $data['data']['publisher'];
            $out = ($a?
            '<div class="col-xs-12 col-sm-'.($data['hasTwitter']?'4':'3').' col-md-'.($data['hasTwitter']?'4':'3').'">':
            '<div class="col-xs-12 col-sm-'.($data['hasTwitter']?'8':'6').' col-md-'.($data['hasTwitter']?'8':'6').' videoBlock">').'
              <div class="secondary-article-wrapper '.($a?'secondary-article':'secondary-video').'">
                <div class="secondary-article-inner">
                  '.(!$a?$this->link_obj(array('path'=>$data['data']['url'], 'remote'=>true, 'data'=>array('videoid'=>$data['data']['video_id']), 'class'=>"content-block-play-btn", 'ga'=>array('a'=>$data['industry'], 'b'=>'Videos'))):'').'
                  <div class="article-meta-wrapper">
                    <div class="favicon_wrapper">'.($favicon!==false?'<img class="favicon" src="'.$favicon.'" alt="">':'').'</div>
		
                    <span class="article-website-truncate">'.$publisher.'</span>
                    <span class="article-website"></span>'.($a?'<span class="visible-sm visible-md" style="height: 0px;"></br></span>':'').'
                    <span class="article-date">'.date("m/d/Y", strtotime($data['data']['publish_date'])).'</span>
                  </div>
                  <span data-truncate="1" class="title_truncate">'.$data['data']['title'].'</span>
                  '.$this->link_obj(array('path'=>$data['data']['url'], 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$data['industry'], 'b'=>($a?'Third Party Article':'Videos')), 'text'=>'<h4 class="article-title"></h4>')).'
                  '.(isset($data['enable_share'])&&$data['enable_share']==true?$this->link_obj(array('path'=>'?url='.urlencode($data['data']['shareId']), 'remote'=>true, 'text'=>'Share ›', 'target'=>'_blank', 'ga'=>array('a'=>'Home', 'b'=>'Share'))):'').'
                  '.$this->image(array(
                    'src'=>$data['data']['image_url'],
                    'class'=>'article-thumbnail'.(!$a?' video-thumbnail':''), 'alt'=>'',
                    'phpThumb'=>($a?array('w'=>223, 'h'=>223, 'zc'=>'C'):array('w'=>491, 'h'=>269, 'zc'=>'C'))
                  )).'
                </div>
              </div>
            </div>';

        } else if ($data['type']=="secondary_twitter") {
            $out = '
                    <div class="secondary-article-wrapper visible-md visible-lg">
                        '.$this->image(array('phpThumb'=>array('f'=>'png', 'w'=>'30'), 'src'=>'/images/social/Twitter_logo_blue.png', 'alt'=>'', 'class'=>'secondary-twitter-logo')).
                      '<div class="secondary-twitter-block-footer">
                        Join the conversation<br><a href="https://twitter.com/search?q=%23'.$data['hashtag'].'">#'.$data['hashtag'].' <a href="https://twitter.com/search?q=%23futureofbiz%">#FutureofBiz</a>
                      </div>
                    ';

            for($i=0;$i<(count($data['data'])<8?count($data['data']):8);$i++) {
                $tweet = $data['data'][$i]['Publishthis_Content']['status_text'];
		$tweet = str_replace('.@', '@', $tweet);
                $tweet = preg_replace("#(^|[\n ])@([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/\\2\">@\\2</a>'", $tweet);
                $tweet = preg_replace("#(^|[\n ])\#([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/search?q=%23\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/search?q=%23\\2\">#\\2</a>'", $tweet);
                $tweet = preg_replace("#(^|[\n ])([\w]+?://[\w]+[^ \"\n\r\t<]*)#ise", "'\\1<a target=\"_blank\" href=\"\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"\\2\">\\2</a>'", $tweet);
                $tweet = preg_replace("#(^|[\n ])((www|ftp)\.[^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://\\2\">\\2</a>'", $tweet);

                $out .= '
                      <div class="secondary-twitter-block-content">
                        <p class="lt-grey">'.$this->link_obj(array('path'=>'http://www.twitter.com/'.$data['data'][$i]['Publishthis_Content']['user_screen_name'],  'target'=>'_blank', 'remote'=>true, 'text'=>$data['data'][$i]['Publishthis_Content']['user_screen_name'], 'ga'=>array('a'=>$industry, 'b'=>'Twitter'))).' '.$tweet.'</p>
                      </div>';
            }
            $out .= '
                    </div>';

        } else if ($data['type']=="secondary_twitter_sm") {
            $out = '
                    <div class="secondary-article-wrapper visible-sm visible-xs">
                        '.$this->image(array('phpThumb'=>array('f'=>'png', 'w'=>'30'), 'src'=>'/images/social/Twitter_logo_blue.png', 'alt'=>'', 'class'=>'secondary-twitter-logo')).
                      '<div class="secondary-twitter-block-footer">
                        Join the conversation<br><a href="https://twitter.com/search?q=%23'.$data['hashtag'].'">#'.$data['hashtag'].' <a href="https://twitter.com/search?q=%23futureofbiz%">#FutureofBiz</a>
                      </div>
                    ';

            for($i=0;$i<(count($data['data'])<8?count($data['data']):8);$i++) {
                $tweet = $data['data'][$i]['Publishthis_Content']['status_text'];
		$tweet = str_replace('.@', '@', $tweet);
                $tweet = preg_replace("#(^|[\n ])@([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/\\2\">@\\2</a>'", $tweet);
                $tweet = preg_replace("#(^|[\n ])\#([^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://www.twitter.com/search?q=%23\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://www.twitter.com/search?q=%23\\2\">#\\2</a>'", $tweet);
                $tweet = preg_replace("#(^|[\n ])([\w]+?://[\w]+[^ \"\n\r\t<]*)#ise", "'\\1<a target=\"_blank\" href=\"\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"\\2\">\\2</a>'", $tweet);
                $tweet = preg_replace("#(^|[\n ])((www|ftp)\.[^ \"\t\n\r<]*)#ise", "'\\1<a target=\"_blank\" href=\"http://\\2\" data-track-event=\"1\" data-ga-a=\"Home\" data-ga-b=\"Twitter\" data-ga-c=\"http://\\2\">\\2</a>'", $tweet);

                $out .= '
                      <div class="secondary-twitter-block-content">
                        <p class="lt-grey">'.$this->link_obj(array('path'=>'http://www.twitter.com/'.$data['data'][$i]['Publishthis_Content']['user_screen_name'],  'target'=>'_blank', 'remote'=>true, 'text'=>$data['data'][$i]['Publishthis_Content']['user_screen_name'], 'ga'=>array('a'=>$industry, 'b'=>'Twitter'))).' '.$tweet.'</p>
                      </div>';
            }
            $out .= '
                    </div>';

        } else if ($data['type']=="secondary_videos") {
            $industry = $data['industry'];
            $data = $data['data'];
            
            $out = '<!-- Media Carousel -->
            <div class="media-carousel-wrapper visible-device">
                <div id="media-carousel" class="carousel slide" data-ride="carousel">
                  <!-- Indicators -->
                  <ol class="carousel-indicators">';
            for($i=0;$i<count($data);$i++) {
                $out .= '<li data-target="#media-carousel" data-slide-to="'.$i.'" class=""></li>';                    
            }
            $out .= '
                  </ol>

                  <!-- Wrapper for slides -->
                  <div class="carousel-inner">';
            for($i=0;$i<count($data);$i++) {
                $out .= '                        
                    <div class="item '.($i==0?'active':'').'">
                     <div class="main-video-wrapper">
                        <div class="video-sm-embed" data-ytembed="1" data-videoid="'.$data[$i]['Publishthis_Content']['video_id'].'" data-track-event="1" data-ga-a="'.$industry.'" data-ga-b="Videos" data-ga-c="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'">
                            <div class="video-container hidden-xs">
                                <iframe id="carousel_player'.$i.'" width="320" height="180" src="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'?autoplay=0&rel=0&enablejsapi=1&html5=1&version=3&controls=0&showinfo=0&origin='.urlencode(SITE_URL).'" frameborder="0" allowfullscreen></iframe>
                            </div>
                            <div class="visible-xs">
                                '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'class'=>'content-block-play-btn', 'target'=>'_blank', 'remote'=>true, 'text'=>'', 'ga'=>array('a'=>$industry, 'b'=>'Videos'))).
                                $this->image(array('src'=>$data[$i]['Publishthis_Content']['image_url'])).'
                            </div>
                        </div>
                        <div class="video-meta">
                          <span class="article-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
                          <h4 class="article-title regular">'.html::truncate($data[$i]['Publishthis_Content']['title'], 45).'</h4>
                          <p>'.html::truncate($data[$i]['Publishthis_Content']['summary'], 190).'</p>
                        </div>
                        <div class="clearfix"></div>
                      </div>
                    </div>';
            }
            $out .= '
                  </div>

                  <!-- Controls -->
                  <a class="left carousel-control" href="#media-carousel" data-slide="prev">
                    <span class="icon-prev"></span>
                  </a>
                  <a class="right carousel-control" href="#media-carousel" data-slide="next">
                    <span class="icon-next"></span>
                  </a>
              </div>
            </div>';
            for($i=0;$i<1;$i++) {
                $out .= '            
            <div class="main-video-wrapper hidden-device">
            <div class="video-lrg-wrapper">
              <div id="video-lrg-embed" data-ytembed="1" data-videoid="'.$data[$i]['Publishthis_Content']['video_id'].'" data-track-event="1" data-ga-a="'.$industry.'" data-ga-b="Videos" data-ga-c="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'">
                  <div class="video-container">
                    <iframe id="spplayer" width="320" height="180" src="http://www.youtube.com/embed/'.$data[$i]['Publishthis_Content']['video_id'].'?autoplay=0&rel=0&enablejsapi=1&html5=1&version=3&controls=0&showinfo=0&origin='.urlencode(SITE_URL).'" frameborder="0" allowfullscreen></iframe>
                  </div>
              </div>
              <div class="video-meta">
                <span class="article-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
                <h4 class="article-title regular">'.html::truncate($data[$i]['Publishthis_Content']['title'], 45).'</h4>
                <p class="article-summary">'.html::truncate($data[$i]['Publishthis_Content']['summary'], 190).'</p>
              </div>
              <div class="clearfix"></div>
            </div>
          </div>';
            }
            $out .= '<div class="small-videos hidden-device">';
            for($i=0;$i<count($data);$i++) {
                //print 'video: '.print_r($data[$i],true).'<br><br>';
                $out .= '
            <div class="single-video-wrapper">              
              <div class="video-thumb-wrapper">
                <div class="video-overlay '.($i==0?'active':'').'" ></div>
                '.$this->link_obj(array(
                    'data'=>array(
                        'date'=>base64_encode(date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date']))),
                        'videoid'=>base64_encode($data[$i]['Publishthis_Content']['video_id']),
                        'title'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['title'], 45)),
                        'summary'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['summary'], 190)),
                        ),
                    'path'=>$data[$i]['Publishthis_Content']['url'],
                    'text'=>$this->image(array('class'=>'small-video-image', 'src'=>$data[$i]['Publishthis_Content']['image_url'], 'alt'=>'')),
                    'ga'=>array('a'=>$industry, 'b'=>'Videos')
                )).'
                </div>
              '.$this->link_obj(array(
                'data'=>array(
                    'date'=>base64_encode(date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date']))),
                    'videoid'=>base64_encode($data[$i]['Publishthis_Content']['video_id']),
                    'title'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['title'], 45)),
                    'summary'=>base64_encode(html::truncate($data[$i]['Publishthis_Content']['summary'], 190)),
                    ),
                'class'=>'small-video-info'.($i==0?' active':''),
                'path'=>$data[$i]['Publishthis_Content']['url'],
                'text'=>'<p>'.$data[$i]['Publishthis_Content']['title'].'</p>',
                'ga'=>array('a'=>$industry, 'b'=>'Videos')
              )).'
            </div>';

            }
          $out .= '</div>';          
          
        } else if ($data['type']=="secondary_blogposts") {
            $industry = $data['industry'];
            $data = $data['data'];
            $out = '<div class="col-md-half-device rp-30"><hr>';
            
            for($i=0;$i<ceil(count($data)/2);$i++) {
                $out .= '
          <div class="secondary-sidebar-content-wrapper">
            <span class="standard">By </span><span class="blog-author">'.$data[$i]['Publishthis_Content']['publisher'].' </span><span class="standard">on </span><span class="blog-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'target'=>'_blank', 'remote'=>true, 'class'=>'white', 'ga'=>array('a'=>$industry, 'b'=>'Business Innovation Blog'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>
          </div>';
            }
            
            $out .= '</div>
          <div class="col-md-half-device lp-30">
            <hr class="visible-sm tsFill">';
            for($i;$i<count($data);$i++) {
              $out .= '
          <div class="secondary-sidebar-content-wrapper">
            <span class="standard">By </span><span class="blog-author">'.$data[$i]['Publishthis_Content']['publisher'].' </span><span class="standard">on </span><span class="blog-date">'.date("F d, Y", strtotime($data[$i]['Publishthis_Content']['publish_date'])).'</span>
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'target'=>'_blank', 'remote'=>true, 'class'=>'white', 'ga'=>array('a'=>$industry, 'b'=>'Business Innovation Blog'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>
          </div>';
            }
            $out .= '</div>';
            
        } else if ($data['type']=="secondary_podcasts") {
            $industry = $data['industry'];
            $data = $data['data'];
            $out = '<div class="col-md-half-device rp-30"><hr>';
            
            for($i=0;$i<ceil(count($data)/2);$i++) {
                $out .= '<div class="secondary-sidebar-content-wrapper" id="jp-interface-jquery_jplayer_'.$i.'">
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'class'=>'white', 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Podcast'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>

            <div id="jquery_jplayer_'.$i.'" class="jp-jplayer" data-mp3="'.base64_encode($data[$i]['Publishthis_Content']['url']).'"></div>
            <div id="jp_container_'.$i.'" class="jp-audio skin2">
              <div class="jp-type-single">
                <div class="jp-gui jp-interface">
                  <div class="jp-controls-container">
                      <ul class="jp-controls">
                        <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-play', 'tabindex'=>1, 'ga'=>array('a'=>$industry, 'b'=>'Podcast', 'c'=>$data[$i]['Publishthis_Content']['url']), 'text'=>$this->image(array('src'=>'play_button2x.png', 'alt'=>'')))).'</li>
                        <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-pause', 'tabindex'=>1, 'text'=>$this->image(array('src'=>'pause_button2x.png', 'alt'=>'')))).'</li>
                      </ul>
                  </div>
                  <div class="jp-progress">
                    <div class="jp-seek-bar">
                      <div class="jp-play-bar"></div>
                    </div>
                  </div>
                  <div class="jp-time-holder-wrapper">
                    <div class="jp-time-holder">
                      <span class="jp-current-time"></span><span> / </span><span class="jp-duration"></span>
                    </div>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="jp-no-solution">
                  <span>Update Required</span>
                  To play the media you will need to either update your browser to a recent version or update your <a href="http://get.adobe.com/flashplayer/" target="_blank">Flash plugin</a>.
                </div>
              </div>
            </div>

            <!--'.$this->image(array('src'=>'icons/podcast-media-player.png', 'alt'=>'')).'-->
          </div>';
            }
            $out .= '        </div>
        <div class="col-md-half-device lp-30"><hr class="visible-sm">';
            for($i;$i<count($data);$i++) {
                $out .= '<div class="secondary-sidebar-content-wrapper" id="jp-interface-jquery_jplayer_'.$i.'">
            '.$this->link_obj(array('path'=>$data[$i]['Publishthis_Content']['url'], 'class'=>'white', 'remote'=>true, 'target'=>'_blank', 'ga'=>array('a'=>$industry, 'b'=>'Podcast'), 'text'=>'<h4 class="blog-title">'.$data[$i]['Publishthis_Content']['title'].'</h4>')).'
            <p>'.$data[$i]['Publishthis_Content']['summary'].'</p>
                
            <div id="jquery_jplayer_'.$i.'" class="jp-jplayer" data-mp3="'.base64_encode($data[$i]['Publishthis_Content']['url']).'"></div>
            <div id="jp_container_'.$i.'" class="jp-audio skin2">
              <div class="jp-type-single">
                <div class="jp-gui jp-interface">
                  <div class="jp-controls-container">
                      <ul class="jp-controls">
                        <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-play', 'tabindex'=>1, 'ga'=>array('a'=>$industry, 'b'=>'Podcast', 'c'=>$data[$i]['Publishthis_Content']['url']), 'text'=>$this->image(array('src'=>'play_button2x.png', 'alt'=>'')))).'</li>
                        <li>'.$this->link_obj(array('path'=>'#', 'class'=>'jp-pause', 'tabindex'=>1, 'text'=>$this->image(array('src'=>'pause_button2x.png', 'alt'=>'')))).'</li>
                      </ul>
                  </div>
                  <div class="jp-progress">
                    <div class="jp-seek-bar">
                      <div class="jp-play-bar"></div>
                    </div>
                  </div>
                  <div class="jp-time-holder-wrapper">
                    <div class="jp-time-holder">
                      <span class="jp-current-time"></span><span> / </span><span class="jp-duration"></span>
                    </div>
                  </div>
                  <div class="clearfix"></div>
                </div>
                <div class="jp-no-solution">
                  <span>Update Required</span>
                  To play the media you will need to either update your browser to a recent version or update your <a href="http://get.adobe.com/flashplayer/" target="_blank">Flash plugin</a>.
                </div>
              </div>
            </div>


            <!--'.$this->image(array('src'=>'icons/podcast-media-player.png', 'alt'=>'')).'-->
          </div>';
            }
            $out .= '</div>';
        } else if ($data['type']=="secondary_additional_content") {
            $data = $data['data'];
            $out = '
          <div class="container secondary-additional-content col-xs-12">'.
                $this->link_obj(array(
                    'target'=>'_blank',
                    'remote'=>true,
                    'path'=>$data['industry']['Industry']['additional_content_url'],
                    'ga'=>array('a'=>$data['industry']['Industry']['title'], 'b'=>'Additional Content', 'c'=>$data['industry']['Industry']['additional_content_url']),
                    'text'=>$data['industry']['Industry']['additional_content_text']." ›"
                )).
          '</div>';

        } else if ($data['type']=="details_modal") {
            $out = '<!-- DETAILS MODAL -->
    <div class="modal" id="details-1">
      <div class="modal-dialog">
        <a href="#" data-dismiss="modal" class="modal-close-tab">'.$this->image(array('src'=>'icons/close-tab.png', 'alt'=>'')).'</a>
          <div class="modal-content">
            <div class="modal-body" id="details-1-embed"></div>
            <div class="modal-footer">
              <a href="#" data-dismiss="modal" class="btn">Close</a>
            </div>
          </div>
        </div>
    </div>';
        } else if ($data['type']=="video_modal") {
$out = '<!-- VIDEO MODAL -->
    <div class="modal" id="video-1">
      <div class="modal-dialog">
        <a href="#" data-dismiss="modal" class="modal-close-tab">'.$this->image(array('src'=>'icons/close-tab.png', 'alt'=>'')).'</a>
          <div class="modal-content">
              <!--
            <div class="modal-header">
              <h4 class="modal-title bold">Video Title</h4>
            </div>
              -->
            <div class="modal-body"><div class="video-container" id="video-1-embed"></div></div>
            <div class="modal-footer">
              <a href="#" data-dismiss="modal" class="btn">Close</a>
            </div>
          </div>
        </div>
    </div>';
        } else if ($data['type']=="newsletter_modal") {
            $out = '<!-- SIGN UP MODAL -->
    <div class="modal" id="sign-up-modal">
      <div class="modal-dialog">
        <a href="#" data-dismiss="modal" class="modal-close-tab">'.$this->image(array('src'=>'icons/close-tab.png', 'alt'=>'')).'</a>
          <div class="modal-content newsletter-container">
            <iframe class="newsletter-iframe" src="'.IFRAME_URL_NEWSLETTER_POPUP.(isset($data['leadformix_id'])?'?m='.$data['leadformix_id']:'').'" frameborder="0" marginwidth="0" marginheight="0" scrolling="no" border="0"></iframe>
            <div class="modal-footer">
              <a href="#" data-dismiss="modal" class="btn">Close</a>
            </div>
          </div>
        </div>
    </div>';
        }
        
        return $out;
    }
}
