<?php

class PublishThisFeed {
    protected $_token = 'bIIBXLi3'; // string
    protected $_feedId = ''; // integer
    private $_minImageSize = ''; // string (small, medium, large)
    private $_sort = 'most_recent'; // string (most_recent, trending_today, trending_pastweek)
    protected $_skip = 0; // numeric
    protected $_results = 10; // numeric (max 50)
    private $_removeWires = 1; // boolean
    private $_removeNearDuplicates = 1; // boolean
    private $_removeNearRelated = 1; // boolean
    private $_contentTypes = ''; // string[]
    private $_includeTopics = 0; // boolean
    private $_includeParentTopics = 0; // boolean
    private $_includeEntities = 0; // boolean
    private $_removeCuratedDocuments = 0; // boolean
    protected $_feedUrl = 'http://webapi.publishthis.com/rest/content/automated/feed/';
    
    public function setToken($token) {
        $this->_token = $token;        
    }
    public function setFeedId($feedId) {
        $this->_feedId = $feedId;        
    }
    public function getFeedId($feedId) {
        return $this->_feedId;
    }
    public function setMinImageSize($size) {
        $this->_minImageSize = $size;
    }
    public function setSort($sort) {
        $this->_sort = $sort;        
    }
    public function setSkip($skip) {
        $this->_skip = $skip;
    }
    public function setResults($results) {
        $this->_results = $results;
    }
    public function setRemoveWires($bool) {
        $this->_removeWires = $bool;
    }
    public function setRemoveNearDuplicates($bool) {
        $this->_removeNearDuplicates = $bool;
    }
    public function setRemoveNearRelated($bool) {
        $this->_removeNearRelated = $bool;
    }
    public function setContentTypes($types) {
        $this->_contentTypes = $types;
    }
    public function setIncludeTopics($bool) {
        $this->_includeTopics = $bool;
    }
    public function setIncludeParentTopics($bool) {
        $this->_includeParentTopics = $bool;
    }
    public function setIncludeEntities($bool) {
        $this->_includeEntities = $bool;
    }
    public function setRemoveCuratedDocuments($bool) {
        $this->_removeCuratedDocuments = $bool;
    }
    protected function prepareUrl() {
        $url = $this->_feedUrl.$this->_feedId.'?token='.$this->_token;
        return $url;
    }
    public function pull() {
        $url = $this->prepareUrl();
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $out = curl_exec($ch);
        curl_close($ch);        
        $data = json_decode($out);
        return $data;
    }

}