<?php
class Template {
     
    protected $variables = array();
    protected $_controller;
    protected $_action;
    protected $_admin = false;
    protected $_inject = array('js'=>array(), 'css'=>array(), 'meta'=>array());
    public $allowPublic = false;
    public $appendCampaignSource = "";

    static public function replace_vars($in, $replace=array()) {
        $s = $r = array();

        if (count($replace)) {
            $k = array_keys($replace);
            for($i=0;$i<count($k);$i++) {
                array_push($s, '{'.$k[$i].'}');
                array_push($r, $replace[$k[$i]]);
            }
        }
        return str_replace($s, $r, $in);
    }

    function __construct($controller,$action) {
        $this->_controller = $controller;
        $this->_action = $action;    
    }
 
    /** Set Variables **/    
    function set($name,$value) {
        $this->variables[$name] = $value;
    }
    
    function admin($bool=false) {
        $this->_admin = $bool;
    }
 
    /** Display Template **/     
    function render($doNotRenderHeader = 0) {
        if ($this->_admin && !$this->allowPublic) {
            $auth = new Authorization();
            $auth->validate();
        }
        
        if (isset($_SESSION['message'])) {
            $this->set('message', $_SESSION['message']);
            unset($_SESSION['message']);
        }
        
        $html = new HTMLHomeBlocks();
        if (isset($_SESSION['campaigncode'])) $html->campaigncode = $_SESSION['campaigncode'];
        if (isset($_SESSION['campaignsource'])) $html->campaignsource = $_SESSION['campaignsource'].$this->appendCampaignSource;
        
        if (isset($_GET['l'])) {
            if ($_GET['l']=="newsletter") {
                $html->setInject('js', '$("#sign-up-modal").modal("show");');
                if (isset($_GET['m'])) {
                    $html->setInject(
                            'js', 
                            '$("#sign-up-modal").find("iframe").each(function() {'
                            .   'var params = new urlVars($(this).attr("src"));'
                            .   'params.set("m", "'.urlencode($_GET['m']).'");'
                            .   '$(this).attr("src", "'.IFRAME_URL_NEWSLETTER_POPUP.'"+params.url());'
                            . '});'
                    );
                            //. '$(this)attr("src", ($(this)attr("src").indexOf("?")==-1?"?":"&")+"m='.urlencode($_GET['m']).'");'
                            //.
                            //. 'src'.IFRAME_URL_NEWSLETTER_POPUP.'?m=");');
                }
            }
        }
        
        extract($this->variables);
        if ($doNotRenderHeader == 0) {
            if (file_exists(ROOT . DS . 'application' . DS . 'views' . DS . $this->_controller . DS . 'header.php')) {
                include (ROOT . DS . 'application' . DS . 'views' . DS . $this->_controller . DS . 'header.php');
            } else {
                include (ROOT . DS . 'application' . DS . 'views' . DS . ($this->_admin?'admin-':'') . 'header.php');
            }
        }
        
        if (file_exists(ROOT . DS . 'application' . DS . 'views' . DS . $this->_controller . DS . $this->_action . '.php')) {
                include (ROOT . DS . 'application' . DS . 'views' . DS . $this->_controller . DS . $this->_action . '.php');		 
        }        
        
        if ($doNotRenderHeader == 0) {
            if (file_exists(ROOT . DS . 'application' . DS . 'views' . DS . $this->_controller . DS . 'footer.php')) {
                include (ROOT . DS . 'application' . DS . 'views' . DS . $this->_controller . DS . 'footer.php');
            } else {
                include (ROOT . DS . 'application' . DS . 'views' . DS . ($this->_admin?'admin-':'') . 'footer.php');
            }
        }
    }
 
}